/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved.   This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 *
 * $Id: ComplementClass.java,v 1.1.1.1 2006/01/31 09:13:24 gxie Exp $
 */
package org.eclipse.eodm.owl;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Complement Class</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>
 * {@link org.eclipse.eodm.owl.ComplementClass#getOWLComplementOf <em>OWL Complement Of</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @see org.eclipse.eodm.owl.OWLPackage#getComplementClass()
 * @model
 * @generated
 */
public interface ComplementClass extends OWLClass {
    /**
     * Returns the value of the '<em><b>OWL Complement Of</b></em>'
     * reference. It is bidirectional and its opposite is '
     * {@link org.eclipse.eodm.owl.OWLClass#getInvOWLComplementOf <em>Inv OWL Complement Of</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>OWL Complement Of</em>' reference.
     * @see #setOWLComplementOf(OWLClass)
     * @see org.eclipse.eodm.owl.OWLPackage#getComplementClass_OWLComplementOf()
     * @see org.eclipse.eodm.owl.OWLClass#getInvOWLComplementOf
     * @model opposite="invOWLComplementOf" required="true"
     * @generated
     */
    OWLClass getOWLComplementOf();

    /**
     * Sets the value of the '
     * {@link org.eclipse.eodm.owl.ComplementClass#getOWLComplementOf <em>OWL Complement Of</em>}'
     * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value
     *            the new value of the '<em>OWL Complement Of</em>'
     *            reference.
     * @see #getOWLComplementOf()
     * @generated
     */
    void setOWLComplementOf(OWLClass value);

} // ComplementClass
