/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved.   This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 *
 * $Id: DatatypeSlot.java,v 1.1.1.1 2006/01/31 09:13:24 gxie Exp $
 */
package org.eclipse.eodm.owl;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Datatype Slot</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link org.eclipse.eodm.owl.DatatypeSlot#getIndividual <em>Individual</em>}
 * </li>
 * <li>{@link org.eclipse.eodm.owl.DatatypeSlot#getContent <em>Content</em>}</li>
 * <li>{@link org.eclipse.eodm.owl.DatatypeSlot#getProperty <em>Property</em>}</li>
 * </ul>
 * </p>
 * 
 * @see org.eclipse.eodm.owl.OWLPackage#getDatatypeSlot()
 * @model
 * @generated
 */
public interface DatatypeSlot extends EObject {
    /**
     * Returns the value of the '<em><b>Individual</b></em>' container
     * reference. It is bidirectional and its opposite is '
     * {@link org.eclipse.eodm.owl.Individual#getDatatypeSlot <em>Datatype Slot</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Individual</em>' container reference.
     * @see #setIndividual(Individual)
     * @see org.eclipse.eodm.owl.OWLPackage#getDatatypeSlot_Individual()
     * @see org.eclipse.eodm.owl.Individual#getDatatypeSlot
     * @model opposite="datatypeSlot"
     * @generated
     */
    Individual getIndividual();

    /**
     * Sets the value of the '
     * {@link org.eclipse.eodm.owl.DatatypeSlot#getIndividual <em>Individual</em>}'
     * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value
     *            the new value of the '<em>Individual</em>' container
     *            reference.
     * @see #getIndividual()
     * @generated
     */
    void setIndividual(Individual value);

    /**
     * Returns the value of the '<em><b>Content</b></em>' containment
     * reference list. The list contents are of type
     * {@link org.eclipse.eodm.rdfs.RDFSLiteral}. It is bidirectional and its
     * opposite is '
     * {@link org.eclipse.eodm.rdfs.RDFSLiteral#getDatatypeSlot <em>Datatype Slot</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Content</em>' containment reference
     *         list.
     * @see org.eclipse.eodm.owl.OWLPackage#getDatatypeSlot_Content()
     * @see org.eclipse.eodm.rdfs.RDFSLiteral#getDatatypeSlot
     * @model type="org.eclipse.rdfs.RDFSLiteral" opposite="DatatypeSlot"
     *        containment="true" required="true"
     * @generated
     */
    EList getContent();

    /**
     * Returns the value of the '<em><b>Property</b></em>' reference. <!--
     * begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Property</em>' reference.
     * @see #setProperty(OWLDatatypeProperty)
     * @see org.eclipse.eodm.owl.OWLPackage#getDatatypeSlot_Property()
     * @model required="true"
     * @generated
     */
    OWLDatatypeProperty getProperty();

    /**
     * Sets the value of the '
     * {@link org.eclipse.eodm.owl.DatatypeSlot#getProperty <em>Property</em>}'
     * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value
     *            the new value of the '<em>Property</em>' reference.
     * @see #getProperty()
     * @generated
     */
    void setProperty(OWLDatatypeProperty value);

} // DatatypeSlot
