/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved.   This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 *
 * $Id: OWLClass.java,v 1.1.1.1 2006/01/31 09:13:24 gxie Exp $
 */
package org.eclipse.eodm.owl;

import org.eclipse.emf.common.util.EList;
import org.eclipse.eodm.rdfs.RDFSClass;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Class</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link org.eclipse.eodm.owl.OWLClass#getDeprecated <em>Deprecated</em>}</li>
 * <li>
 * {@link org.eclipse.eodm.owl.OWLClass#getInvOWLEquivalentClass <em>Inv OWL Equivalent Class</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.OWLClass#getOWLEquivalentClass <em>OWL Equivalent Class</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.OWLClass#getOWLDisjointWith <em>OWL Disjoint With</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.OWLClass#getInvOWLDisjointWith <em>Inv OWL Disjoint With</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.OWLClass#getRefByIntersectionClass <em>Ref By Intersection Class</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.OWLClass#getRefByUnionClass <em>Ref By Union Class</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.OWLClass#getInvOWLComplementOf <em>Inv OWL Complement Of</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @see org.eclipse.eodm.owl.OWLPackage#getOWLClass()
 * @model
 * @generated
 */
public interface OWLClass extends RDFSClass {
    /**
     * Returns the value of the '<em><b>Deprecated</b></em>' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc --> <!-- begin-model-doc -->
     * default: false <!-- end-model-doc -->
     * 
     * @return the value of the '<em>Deprecated</em>' attribute.
     * @see #setDeprecated(Boolean)
     * @see org.eclipse.eodm.owl.OWLPackage#getOWLClass_Deprecated()
     * @model
     * @generated
     */
    Boolean getDeprecated();

    /**
     * Sets the value of the '
     * {@link org.eclipse.eodm.owl.OWLClass#getDeprecated <em>Deprecated</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value
     *            the new value of the '<em>Deprecated</em>' attribute.
     * @see #getDeprecated()
     * @generated
     */
    void setDeprecated(Boolean value);

    /**
     * Returns the value of the '<em><b>Inv OWL Equivalent Class</b></em>'
     * reference list. The list contents are of type
     * {@link org.eclipse.eodm.owl.OWLClass}. It is bidirectional and its opposite
     * is '
     * {@link org.eclipse.eodm.owl.OWLClass#getOWLEquivalentClass <em>OWL Equivalent Class</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Inv OWL Equivalent Class</em>'
     *         reference list.
     * @see org.eclipse.eodm.owl.OWLPackage#getOWLClass_InvOWLEquivalentClass()
     * @see org.eclipse.eodm.owl.OWLClass#getOWLEquivalentClass
     * @model type="org.eclipse.owl.OWLClass" opposite="OWLEquivalentClass"
     * @generated
     */
    EList getInvOWLEquivalentClass();

    /**
     * Returns the value of the '<em><b>OWL Equivalent Class</b></em>'
     * reference list. The list contents are of type
     * {@link org.eclipse.eodm.owl.OWLClass}. It is bidirectional and its opposite
     * is '
     * {@link org.eclipse.eodm.owl.OWLClass#getInvOWLEquivalentClass <em>Inv OWL Equivalent Class</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>OWL Equivalent Class</em>' reference
     *         list.
     * @see org.eclipse.eodm.owl.OWLPackage#getOWLClass_OWLEquivalentClass()
     * @see org.eclipse.eodm.owl.OWLClass#getInvOWLEquivalentClass
     * @model type="org.eclipse.owl.OWLClass" opposite="invOWLEquivalentClass"
     * @generated
     */
    EList getOWLEquivalentClass();

    /**
     * Returns the value of the '<em><b>OWL Disjoint With</b></em>'
     * reference list. The list contents are of type
     * {@link org.eclipse.eodm.owl.OWLClass}. It is bidirectional and its opposite
     * is '
     * {@link org.eclipse.eodm.owl.OWLClass#getInvOWLDisjointWith <em>Inv OWL Disjoint With</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>OWL Disjoint With</em>' reference list.
     * @see org.eclipse.eodm.owl.OWLPackage#getOWLClass_OWLDisjointWith()
     * @see org.eclipse.eodm.owl.OWLClass#getInvOWLDisjointWith
     * @model type="org.eclipse.owl.OWLClass" opposite="invOWLDisjointWith"
     * @generated
     */
    EList getOWLDisjointWith();

    /**
     * Returns the value of the '<em><b>Inv OWL Disjoint With</b></em>'
     * reference list. The list contents are of type
     * {@link org.eclipse.eodm.owl.OWLClass}. It is bidirectional and its opposite
     * is '
     * {@link org.eclipse.eodm.owl.OWLClass#getOWLDisjointWith <em>OWL Disjoint With</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Inv OWL Disjoint With</em>' reference
     *         list.
     * @see org.eclipse.eodm.owl.OWLPackage#getOWLClass_InvOWLDisjointWith()
     * @see org.eclipse.eodm.owl.OWLClass#getOWLDisjointWith
     * @model type="org.eclipse.owl.OWLClass" opposite="OWLDisjointWith"
     * @generated
     */
    EList getInvOWLDisjointWith();

    /**
     * Returns the value of the '<em><b>Ref By Intersection Class</b></em>'
     * reference list. The list contents are of type
     * {@link org.eclipse.eodm.owl.IntersectionClass}. It is bidirectional and its
     * opposite is '
     * {@link org.eclipse.eodm.owl.IntersectionClass#getOWLIntersectionOf <em>OWL Intersection Of</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Ref By Intersection Class</em>'
     *         reference list.
     * @see org.eclipse.eodm.owl.OWLPackage#getOWLClass_RefByIntersectionClass()
     * @see org.eclipse.eodm.owl.IntersectionClass#getOWLIntersectionOf
     * @model type="org.eclipse.owl.IntersectionClass"
     *        opposite="OWLIntersectionOf"
     * @generated
     */
    EList getRefByIntersectionClass();

    /**
     * Returns the value of the '<em><b>Ref By Union Class</b></em>'
     * reference list. The list contents are of type
     * {@link org.eclipse.eodm.owl.UnionClass}. It is bidirectional and its opposite
     * is '
     * {@link org.eclipse.eodm.owl.UnionClass#getOWLUnionOf <em>OWL Union Of</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Ref By Union Class</em>' reference
     *         list.
     * @see org.eclipse.eodm.owl.OWLPackage#getOWLClass_RefByUnionClass()
     * @see org.eclipse.eodm.owl.UnionClass#getOWLUnionOf
     * @model type="org.eclipse.owl.UnionClass" opposite="OWLUnionOf"
     * @generated
     */
    EList getRefByUnionClass();

    /**
     * Returns the value of the '<em><b>Inv OWL Complement Of</b></em>'
     * reference list. The list contents are of type
     * {@link org.eclipse.eodm.owl.ComplementClass}. It is bidirectional and its
     * opposite is '
     * {@link org.eclipse.eodm.owl.ComplementClass#getOWLComplementOf <em>OWL Complement Of</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Inv OWL Complement Of</em>' reference
     *         list.
     * @see org.eclipse.eodm.owl.OWLPackage#getOWLClass_InvOWLComplementOf()
     * @see org.eclipse.eodm.owl.ComplementClass#getOWLComplementOf
     * @model type="org.eclipse.owl.ComplementClass" opposite="OWLComplementOf"
     * @generated
     */
    EList getInvOWLComplementOf();

} // OWLClass
