/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved.   This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 *
 * $Id: OWLFactory.java,v 1.1.1.1 2006/01/31 09:13:24 gxie Exp $
 */

/////
package org.eclipse.eodm.owl;

import org.eclipse.emf.ecore.EFactory;
import org.eclipse.eodm.rdfs.Namespace;
import org.eclipse.eodm.rdfs.RDFSClass;
import org.eclipse.eodm.rdfs.RDFSDatatype;
import org.eclipse.eodm.rdfs.RDFSLiteral;
import org.eclipse.eodm.rdfs.RDFSResource;

/**
 * <!-- begin-user-doc --> The <b>Factory </b> for the model. It provides a
 * create method for each non-abstract class of the model. <!-- end-user-doc -->
 * 
 * @see org.eclipse.eodm.owl.OWLPackage
 * @generated
 */
public interface OWLFactory extends EFactory {
    /**
     * The singleton instance of the factory. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    OWLFactory eINSTANCE = new org.eclipse.eodm.owl.impl.OWLFactoryImpl();

    /**
     * Returns a new object of class '<em>Ontology</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Ontology</em>'.
     * @generated
     */
    OWLOntology createOWLOntology();
    
    /**
     * @param localName
     * @return
     */
    OWLOntology createOWLOntology(String localName);

    /**
     * Returns a new object of class '<em>Ontology Property</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Ontology Property</em>'.
     * @generated
     */
    OWLOntologyProperty createOWLOntologyProperty();
    
    /**
     * Returns a new object of class '<em>Class</em>'. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Class</em>'.
     * @generated
     */
    OWLClass createOWLClass();
    
    /**
     * @param ontology
     * @param localName
     * @param ns
     * @return
     */
    OWLClass createOWLClass(OWLOntology ontology, String localName, Namespace ns);
    
    /**
     * @param ontology
     * @param localName
     * @return
     */
    OWLClass createOWLClass(OWLOntology ontology, String localName);

    /**
     * Returns a new object of class '<em>Object Property</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Object Property</em>'.
     * @generated
     */
    OWLObjectProperty createOWLObjectProperty();
    
    /**
     * @param ontology
     * @param localName
     * @param ns
     * @return
     */
    OWLObjectProperty createOWLObjectProperty(OWLOntology ontology, String localName, Namespace ns);
    
    /**
     * @param ontology
     * @param localName
     * @param ns
     * @param domain
     * @param range
     * @return
     */
    OWLObjectProperty createOWLObjectProperty(OWLOntology ontology, 
            String localName, Namespace ns, OWLClass domain, OWLClass range);
    
    /**
     * @param ontology
     * @param localName
     * @return
     */
    OWLObjectProperty createOWLObjectProperty(OWLOntology ontology, String localName);
    
    /**
     * @param ontology
     * @param localName
     * @param domain
     * @param range
     * @return
     */
    OWLObjectProperty createOWLObjectProperty(OWLOntology ontology, 
            String localName, OWLClass domain, OWLClass range);

    /**
     * Returns a new object of class '<em>Property</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Property</em>'.
     * @generated
     */
    Property createProperty();

    /**
     * Returns a new object of class '<em>Datatype Property</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Datatype Property</em>'.
     * @generated
     */
    OWLDatatypeProperty createOWLDatatypeProperty();
    
    /**
     * @param ontology
     * @param localName
     * @param ns
     * @return
     */
    OWLDatatypeProperty createOWLDatatypeProperty(OWLOntology ontology, String localName, Namespace ns);
    
    /**
     * @param ontology
     * @param localName
     * @param ns
     * @param domain
     * @param range
     * @return
     */
    OWLDatatypeProperty createOWLDatatypeProperty(OWLOntology ontology, 
            String localName, Namespace ns, OWLClass domain, RDFSDatatype range);
    
    /**
     * @param ontology
     * @param localName
     * @return
     */
    OWLDatatypeProperty createOWLDatatypeProperty(OWLOntology ontology, String localName);
    
    /**
     * @param ontology
     * @param localName
     * @param domain
     * @param range
     * @return
     */
    OWLDatatypeProperty createOWLDatatypeProperty(OWLOntology ontology, 
            String localName, OWLClass domain, RDFSDatatype range);

    /**
     * Returns a new object of class '<em>Individual</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Individual</em>'.
     * @generated
     */
    Individual createIndividual();
        
    /**
     * @param ontology
     * @param localName
     * @param ns
     * @param type
     * @return
     */
    Individual createIndividual(OWLOntology ontology, String localName, Namespace ns, OWLClass type);
        
    /**
     * @param ontology
     * @param localName
     * @param type
     * @return
     */
    Individual createIndividual(OWLOntology ontology, String localName, OWLClass type);

    /**
     * Returns a new object of class '<em>All Different</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>All Different</em>'.
     * @generated
     */
    OWLAllDifferent createOWLAllDifferent();

    /**
     * Returns a new object of class '<em>Data Range</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Data Range</em>'.
     * @generated
     */
    OWLDataRange createOWLDataRange();
    
    /**
     * @param ontology
     * @param localName
     * @return
     */
    OWLDataRange createOWLDataRange(OWLOntology ontology, String localName);
    
    /**
     * @param ontology
     * @param localName
     * @param ns
     * @return
     */
    OWLDataRange createOWLDataRange(OWLOntology ontology, String localName, Namespace ns);

    /**
     * Returns a new object of class '<em>Annotation Property</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Annotation Property</em>'.
     * @generated
     */
    OWLAnnotationProperty createOWLAnnotationProperty();

    /**
     * Returns a new object of class '<em>Datatype Slot</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Datatype Slot</em>'.
     * @generated
     */
    DatatypeSlot createDatatypeSlot();
    
    /**
     * @param individual
     * @param property
     * @param content
     * @return
     */
    DatatypeSlot createDatatypeSlot(Individual individual, OWLDatatypeProperty property, RDFSLiteral content);

    /**
     * Returns a new object of class '<em>Object Slot</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Object Slot</em>'.
     * @generated
     */
    ObjectSlot createObjectSlot();
    
    /**
     * @param individual
     * @param property
     * @param content
     * @return
     */
    ObjectSlot createObjectSlot(Individual individual, OWLObjectProperty property, Individual content);

    /**
     * Returns a new object of class '<em>Enumerated Class</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Enumerated Class</em>'.
     * @generated
     */
    EnumeratedClass createEnumeratedClass();
    
    /**
     * @param ontology
     * @param localName
     * @param ns
     * @return
     */
    EnumeratedClass createEnumeratedClass(OWLOntology ontology, String localName, Namespace ns);
    
    /**
     * @param ontology
     * @param localName
     * @return
     */
    EnumeratedClass createEnumeratedClass(OWLOntology ontology, String localName);

    /**
     * Returns a new object of class '<em>Intersection Class</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Intersection Class</em>'.
     * @generated
     */
    IntersectionClass createIntersectionClass();
    
    /**
     * @param ontology
     * @param localName
     * @param ns
     * @return
     */
    IntersectionClass createIntersectionClass(OWLOntology ontology, String localName, Namespace ns);
    
    /**
     * @param ontology
     * @param localName
     * @return
     */
    IntersectionClass createIntersectionClass(OWLOntology ontology, String localName);

    /**
     * Returns a new object of class '<em>Union Class</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Union Class</em>'.
     * @generated
     */
    UnionClass createUnionClass();
    
    /**
     * @param ontology
     * @param localName
     * @param ns
     * @return
     */
    UnionClass createUnionClass(OWLOntology ontology, String localName, Namespace ns);
    
    /**
     * @param ontology
     * @param localName
     * @return
     */
    UnionClass createUnionClass(OWLOntology ontology, String localName);

    /**
     * Returns a new object of class '<em>Has Value Restriction</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Has Value Restriction</em>'.
     * @generated
     */
    HasValueRestriction createHasValueRestriction();
    
    /**
     * @param ontology
     * @param onProperty
     * @param value
     * @return
     */
    HasValueRestriction createHasValueRestriction(OWLOntology ontology, Property onProperty, RDFSResource value);    

    /**
     * Returns a new object of class '<em>All Values From Restriction</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>All Values From Restriction</em>'.
     * @generated
     */
    AllValuesFromRestriction createAllValuesFromRestriction();
    
    /**
     * @param ontology
     * @param onProperty
     * @param value
     * @return
     */
    AllValuesFromRestriction createAllValuesFromRestriction(OWLOntology ontology, Property onProperty, RDFSClass value);

    /**
     * Returns a new object of class '<em>Some Values From Restriction</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Some Values From Restriction</em>'.
     * @generated
     */
    SomeValuesFromRestriction createSomeValuesFromRestriction();
    
    /**
     * @param ontology
     * @param onProperty
     * @param value
     * @return
     */
    SomeValuesFromRestriction createSomeValuesFromRestriction(OWLOntology ontology, Property onProperty, RDFSClass value);

    /**
     * Returns a new object of class '<em>Cardinality Restriction</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Cardinality Restriction</em>'.
     * @generated
     */
    CardinalityRestriction createCardinalityRestriction();
    
    /**
     * @param ontology
     * @param onProperty
     * @param value
     * @return
     */
    CardinalityRestriction createCardinalityRestriction(OWLOntology ontology, Property onProperty, RDFSLiteral value);

    /**
     * Returns a new object of class '<em>Max Cardinality Restriction</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Max Cardinality Restriction</em>'.
     * @generated
     */
    MaxCardinalityRestriction createMaxCardinalityRestriction();
    
    /**
     * @param ontology
     * @param onProperty
     * @param value
     * @return
     */
    MaxCardinalityRestriction createMaxCardinalityRestriction(OWLOntology ontology, Property onProperty, RDFSLiteral value);

    /**
     * Returns a new object of class '<em>Min Cardinality Restriction</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Min Cardinality Restriction</em>'.
     * @generated
     */
    MinCardinalityRestriction createMinCardinalityRestriction();
    
    /**
     * @param ontology
     * @param onProperty
     * @param value
     * @return
     */
    MinCardinalityRestriction createMinCardinalityRestriction(OWLOntology ontology, Property onProperty, RDFSLiteral value);

    /**
     * Returns a new object of class '<em>Complement Class</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Complement Class</em>'.
     * @generated
     */
    ComplementClass createComplementClass();
    
    /**
     * @param ontology
     * @param localName
     * @param ns
     * @param complement
     * @return
     */
    ComplementClass createComplementClass(OWLOntology ontology, String localName, Namespace ns, OWLClass complement);
    
    /**
     * @param ontology
     * @param localName
     * @param complement
     * @return
     */
    ComplementClass createComplementClass(OWLOntology ontology, String localName, OWLClass complement);
    
    /**
     * @param ontology
     * @param localName
     * @param complement
     * @return
     */

    /**
     * Returns the package supported by this factory. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the package supported by this factory.
     * @generated
     */
    OWLPackage getOWLPackage();

} //OWLFactory
