/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved.   This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 *
 * $Id: ComplementClassImpl.java,v 1.1.1.1 2006/01/31 09:13:24 gxie Exp $
 */
package org.eclipse.eodm.owl.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.eodm.owl.ComplementClass;
import org.eclipse.eodm.owl.OWLClass;
import org.eclipse.eodm.owl.OWLPackage;
import org.eclipse.eodm.rdfs.Namespace;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Complement Class</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link org.eclipse.eodm.owl.impl.ComplementClassImpl#getOWLComplementOf <em>OWL Complement Of</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class ComplementClassImpl extends OWLClassImpl implements
        ComplementClass {
    /**
     * The cached value of the '
     * {@link #getOWLComplementOf() <em>OWL Complement Of</em>}' reference.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getOWLComplementOf()
     * @generated
     * @ordered
     */
    protected OWLClass owlComplementOf = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected ComplementClassImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected EClass eStaticClass() {
        return OWLPackage.eINSTANCE.getComplementClass();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public OWLClass getOWLComplementOf() {
        if (owlComplementOf != null && owlComplementOf.eIsProxy()) {
            OWLClass oldOWLComplementOf = owlComplementOf;
            owlComplementOf = (OWLClass) eResolveProxy((InternalEObject) owlComplementOf);
            if (owlComplementOf != oldOWLComplementOf) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE,
                            OWLPackage.COMPLEMENT_CLASS__OWL_COMPLEMENT_OF,
                            oldOWLComplementOf, owlComplementOf));
            }
        }
        return owlComplementOf;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public OWLClass basicGetOWLComplementOf() {
        return owlComplementOf;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain basicSetOWLComplementOf(
            OWLClass newOWLComplementOf, NotificationChain msgs) {
        OWLClass oldOWLComplementOf = owlComplementOf;
        owlComplementOf = newOWLComplementOf;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this,
                    Notification.SET,
                    OWLPackage.COMPLEMENT_CLASS__OWL_COMPLEMENT_OF,
                    oldOWLComplementOf, newOWLComplementOf);
            if (msgs == null)
                msgs = notification;
            else
                msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setOWLComplementOf(OWLClass newOWLComplementOf) {
        if (newOWLComplementOf != owlComplementOf) {
            NotificationChain msgs = null;
            if (owlComplementOf != null)
                msgs = ((InternalEObject) owlComplementOf).eInverseRemove(this,
                        OWLPackage.OWL_CLASS__INV_OWL_COMPLEMENT_OF,
                        OWLClass.class, msgs);
            if (newOWLComplementOf != null)
                msgs = ((InternalEObject) newOWLComplementOf).eInverseAdd(this,
                        OWLPackage.OWL_CLASS__INV_OWL_COMPLEMENT_OF,
                        OWLClass.class, msgs);
            msgs = basicSetOWLComplementOf(newOWLComplementOf, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    OWLPackage.COMPLEMENT_CLASS__OWL_COMPLEMENT_OF,
                    newOWLComplementOf, newOWLComplementOf));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseAdd(InternalEObject otherEnd,
            int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case OWLPackage.COMPLEMENT_CLASS__SUBJECT_STATEMENT:
                return ((InternalEList) getSubjectStatement()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__OBJECT_STATEMENT:
                return ((InternalEList) getObjectStatement()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__RDF_TYPE:
                return ((InternalEList) getRDFType()).basicAdd(otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__PREDICATE_STATEMENT:
                return ((InternalEList) getPredicateStatement()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__REF_BY_AVF_RESTRICTION:
                return ((InternalEList) getRefByAVFRestriction()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__REF_BY_SVF_RESTRICTION:
                return ((InternalEList) getRefBySVFRestriction()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__RDFS_SUB_CLASS_OF:
                return ((InternalEList) getRDFSSubClassOf()).basicAdd(otherEnd,
                        msgs);
            case OWLPackage.COMPLEMENT_CLASS__SUB_CLASS:
                return ((InternalEList) getSubClass()).basicAdd(otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__OWNED_PROPERTY:
                return ((InternalEList) getOwnedProperty()).basicAdd(otherEnd,
                        msgs);
            case OWLPackage.COMPLEMENT_CLASS__RANGED_BY_PROPERTY:
                return ((InternalEList) getRangedByProperty()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__INSTANCE:
                return ((InternalEList) getInstance()).basicAdd(otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__INV_OWL_EQUIVALENT_CLASS:
                return ((InternalEList) getInvOWLEquivalentClass()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__OWL_EQUIVALENT_CLASS:
                return ((InternalEList) getOWLEquivalentClass()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__OWL_DISJOINT_WITH:
                return ((InternalEList) getOWLDisjointWith()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__INV_OWL_DISJOINT_WITH:
                return ((InternalEList) getInvOWLDisjointWith()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__REF_BY_INTERSECTION_CLASS:
                return ((InternalEList) getRefByIntersectionClass()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__REF_BY_UNION_CLASS:
                return ((InternalEList) getRefByUnionClass()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__INV_OWL_COMPLEMENT_OF:
                return ((InternalEList) getInvOWLComplementOf()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__OWL_COMPLEMENT_OF:
                if (owlComplementOf != null)
                    msgs = ((InternalEObject) owlComplementOf).eInverseRemove(
                            this, OWLPackage.OWL_CLASS__INV_OWL_COMPLEMENT_OF,
                            OWLClass.class, msgs);
                return basicSetOWLComplementOf((OWLClass) otherEnd, msgs);
            default:
                return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
            }
        }
        if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
        return eBasicSetContainer(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseRemove(InternalEObject otherEnd,
            int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case OWLPackage.COMPLEMENT_CLASS__SUBJECT_STATEMENT:
                return ((InternalEList) getSubjectStatement()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__OBJECT_STATEMENT:
                return ((InternalEList) getObjectStatement()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__RDF_TYPE:
                return ((InternalEList) getRDFType()).basicRemove(otherEnd,
                        msgs);
            case OWLPackage.COMPLEMENT_CLASS__PREDICATE_STATEMENT:
                return ((InternalEList) getPredicateStatement()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__REF_BY_AVF_RESTRICTION:
                return ((InternalEList) getRefByAVFRestriction()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__REF_BY_SVF_RESTRICTION:
                return ((InternalEList) getRefBySVFRestriction()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__RDFS_SUB_CLASS_OF:
                return ((InternalEList) getRDFSSubClassOf()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__SUB_CLASS:
                return ((InternalEList) getSubClass()).basicRemove(otherEnd,
                        msgs);
            case OWLPackage.COMPLEMENT_CLASS__OWNED_PROPERTY:
                return ((InternalEList) getOwnedProperty()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__RANGED_BY_PROPERTY:
                return ((InternalEList) getRangedByProperty()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__INSTANCE:
                return ((InternalEList) getInstance()).basicRemove(otherEnd,
                        msgs);
            case OWLPackage.COMPLEMENT_CLASS__INV_OWL_EQUIVALENT_CLASS:
                return ((InternalEList) getInvOWLEquivalentClass())
                        .basicRemove(otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__OWL_EQUIVALENT_CLASS:
                return ((InternalEList) getOWLEquivalentClass()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__OWL_DISJOINT_WITH:
                return ((InternalEList) getOWLDisjointWith()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__INV_OWL_DISJOINT_WITH:
                return ((InternalEList) getInvOWLDisjointWith()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__REF_BY_INTERSECTION_CLASS:
                return ((InternalEList) getRefByIntersectionClass())
                        .basicRemove(otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__REF_BY_UNION_CLASS:
                return ((InternalEList) getRefByUnionClass()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__INV_OWL_COMPLEMENT_OF:
                return ((InternalEList) getInvOWLComplementOf()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.COMPLEMENT_CLASS__OWL_COMPLEMENT_OF:
                return basicSetOWLComplementOf(null, msgs);
            default:
                return eDynamicInverseRemove(otherEnd, featureID, baseClass,
                        msgs);
            }
        }
        return eBasicSetContainer(null, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Object eGet(EStructuralFeature eFeature, boolean resolve) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case OWLPackage.COMPLEMENT_CLASS__LOCAL_NAME:
            return getLocalName();
        case OWLPackage.COMPLEMENT_CLASS__URI:
            return getURI();
        case OWLPackage.COMPLEMENT_CLASS__SUBJECT_STATEMENT:
            return getSubjectStatement();
        case OWLPackage.COMPLEMENT_CLASS__OBJECT_STATEMENT:
            return getObjectStatement();
        case OWLPackage.COMPLEMENT_CLASS__RDFS_IS_DEFINED_BY:
            return getRDFSIsDefinedBy();
        case OWLPackage.COMPLEMENT_CLASS__RDF_VALUE:
            return getRDFValue();
        case OWLPackage.COMPLEMENT_CLASS__RDFS_SEE_ALSO:
            return getRDFSSeeAlso();
        case OWLPackage.COMPLEMENT_CLASS__RDF_TYPE:
            return getRDFType();
        case OWLPackage.COMPLEMENT_CLASS__RDFS_MEMBER:
            return getRDFSMember();
        case OWLPackage.COMPLEMENT_CLASS__PREDICATE_STATEMENT:
            return getPredicateStatement();
        case OWLPackage.COMPLEMENT_CLASS__RDFS_COMMENT:
            return getRDFSComment();
        case OWLPackage.COMPLEMENT_CLASS__RDFS_LABEL:
            return getRDFSLabel();
        case OWLPackage.COMPLEMENT_CLASS__NAMESPACE:
            if (resolve)
                return getNamespace();
            return basicGetNamespace();
        case OWLPackage.COMPLEMENT_CLASS__REF_BY_AVF_RESTRICTION:
            return getRefByAVFRestriction();
        case OWLPackage.COMPLEMENT_CLASS__REF_BY_SVF_RESTRICTION:
            return getRefBySVFRestriction();
        case OWLPackage.COMPLEMENT_CLASS__RDFS_SUB_CLASS_OF:
            return getRDFSSubClassOf();
        case OWLPackage.COMPLEMENT_CLASS__SUB_CLASS:
            return getSubClass();
        case OWLPackage.COMPLEMENT_CLASS__OWNED_PROPERTY:
            return getOwnedProperty();
        case OWLPackage.COMPLEMENT_CLASS__RANGED_BY_PROPERTY:
            return getRangedByProperty();
        case OWLPackage.COMPLEMENT_CLASS__INSTANCE:
            return getInstance();
        case OWLPackage.COMPLEMENT_CLASS__DEPRECATED:
            return getDeprecated();
        case OWLPackage.COMPLEMENT_CLASS__INV_OWL_EQUIVALENT_CLASS:
            return getInvOWLEquivalentClass();
        case OWLPackage.COMPLEMENT_CLASS__OWL_EQUIVALENT_CLASS:
            return getOWLEquivalentClass();
        case OWLPackage.COMPLEMENT_CLASS__OWL_DISJOINT_WITH:
            return getOWLDisjointWith();
        case OWLPackage.COMPLEMENT_CLASS__INV_OWL_DISJOINT_WITH:
            return getInvOWLDisjointWith();
        case OWLPackage.COMPLEMENT_CLASS__REF_BY_INTERSECTION_CLASS:
            return getRefByIntersectionClass();
        case OWLPackage.COMPLEMENT_CLASS__REF_BY_UNION_CLASS:
            return getRefByUnionClass();
        case OWLPackage.COMPLEMENT_CLASS__INV_OWL_COMPLEMENT_OF:
            return getInvOWLComplementOf();
        case OWLPackage.COMPLEMENT_CLASS__OWL_COMPLEMENT_OF:
            if (resolve)
                return getOWLComplementOf();
            return basicGetOWLComplementOf();
        }
        return eDynamicGet(eFeature, resolve);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eSet(EStructuralFeature eFeature, Object newValue) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case OWLPackage.COMPLEMENT_CLASS__LOCAL_NAME:
            setLocalName((String) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__SUBJECT_STATEMENT:
            getSubjectStatement().clear();
            getSubjectStatement().addAll((Collection) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__OBJECT_STATEMENT:
            getObjectStatement().clear();
            getObjectStatement().addAll((Collection) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__RDFS_IS_DEFINED_BY:
            getRDFSIsDefinedBy().clear();
            getRDFSIsDefinedBy().addAll((Collection) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__RDF_VALUE:
            getRDFValue().clear();
            getRDFValue().addAll((Collection) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__RDFS_SEE_ALSO:
            getRDFSSeeAlso().clear();
            getRDFSSeeAlso().addAll((Collection) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__RDF_TYPE:
            getRDFType().clear();
            getRDFType().addAll((Collection) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__RDFS_MEMBER:
            getRDFSMember().clear();
            getRDFSMember().addAll((Collection) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__PREDICATE_STATEMENT:
            getPredicateStatement().clear();
            getPredicateStatement().addAll((Collection) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__RDFS_COMMENT:
            getRDFSComment().clear();
            getRDFSComment().addAll((Collection) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__RDFS_LABEL:
            getRDFSLabel().clear();
            getRDFSLabel().addAll((Collection) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__NAMESPACE:
            setNamespace((Namespace) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__REF_BY_AVF_RESTRICTION:
            getRefByAVFRestriction().clear();
            getRefByAVFRestriction().addAll((Collection) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__REF_BY_SVF_RESTRICTION:
            getRefBySVFRestriction().clear();
            getRefBySVFRestriction().addAll((Collection) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__RDFS_SUB_CLASS_OF:
            getRDFSSubClassOf().clear();
            getRDFSSubClassOf().addAll((Collection) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__SUB_CLASS:
            getSubClass().clear();
            getSubClass().addAll((Collection) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__OWNED_PROPERTY:
            getOwnedProperty().clear();
            getOwnedProperty().addAll((Collection) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__RANGED_BY_PROPERTY:
            getRangedByProperty().clear();
            getRangedByProperty().addAll((Collection) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__INSTANCE:
            getInstance().clear();
            getInstance().addAll((Collection) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__DEPRECATED:
            setDeprecated((Boolean) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__INV_OWL_EQUIVALENT_CLASS:
            getInvOWLEquivalentClass().clear();
            getInvOWLEquivalentClass().addAll((Collection) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__OWL_EQUIVALENT_CLASS:
            getOWLEquivalentClass().clear();
            getOWLEquivalentClass().addAll((Collection) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__OWL_DISJOINT_WITH:
            getOWLDisjointWith().clear();
            getOWLDisjointWith().addAll((Collection) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__INV_OWL_DISJOINT_WITH:
            getInvOWLDisjointWith().clear();
            getInvOWLDisjointWith().addAll((Collection) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__REF_BY_INTERSECTION_CLASS:
            getRefByIntersectionClass().clear();
            getRefByIntersectionClass().addAll((Collection) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__REF_BY_UNION_CLASS:
            getRefByUnionClass().clear();
            getRefByUnionClass().addAll((Collection) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__INV_OWL_COMPLEMENT_OF:
            getInvOWLComplementOf().clear();
            getInvOWLComplementOf().addAll((Collection) newValue);
            return;
        case OWLPackage.COMPLEMENT_CLASS__OWL_COMPLEMENT_OF:
            setOWLComplementOf((OWLClass) newValue);
            return;
        }
        eDynamicSet(eFeature, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eUnset(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case OWLPackage.COMPLEMENT_CLASS__LOCAL_NAME:
            setLocalName(LOCAL_NAME_EDEFAULT);
            return;
        case OWLPackage.COMPLEMENT_CLASS__SUBJECT_STATEMENT:
            getSubjectStatement().clear();
            return;
        case OWLPackage.COMPLEMENT_CLASS__OBJECT_STATEMENT:
            getObjectStatement().clear();
            return;
        case OWLPackage.COMPLEMENT_CLASS__RDFS_IS_DEFINED_BY:
            getRDFSIsDefinedBy().clear();
            return;
        case OWLPackage.COMPLEMENT_CLASS__RDF_VALUE:
            getRDFValue().clear();
            return;
        case OWLPackage.COMPLEMENT_CLASS__RDFS_SEE_ALSO:
            getRDFSSeeAlso().clear();
            return;
        case OWLPackage.COMPLEMENT_CLASS__RDF_TYPE:
            getRDFType().clear();
            return;
        case OWLPackage.COMPLEMENT_CLASS__RDFS_MEMBER:
            getRDFSMember().clear();
            return;
        case OWLPackage.COMPLEMENT_CLASS__PREDICATE_STATEMENT:
            getPredicateStatement().clear();
            return;
        case OWLPackage.COMPLEMENT_CLASS__RDFS_COMMENT:
            getRDFSComment().clear();
            return;
        case OWLPackage.COMPLEMENT_CLASS__RDFS_LABEL:
            getRDFSLabel().clear();
            return;
        case OWLPackage.COMPLEMENT_CLASS__NAMESPACE:
            setNamespace((Namespace) null);
            return;
        case OWLPackage.COMPLEMENT_CLASS__REF_BY_AVF_RESTRICTION:
            getRefByAVFRestriction().clear();
            return;
        case OWLPackage.COMPLEMENT_CLASS__REF_BY_SVF_RESTRICTION:
            getRefBySVFRestriction().clear();
            return;
        case OWLPackage.COMPLEMENT_CLASS__RDFS_SUB_CLASS_OF:
            getRDFSSubClassOf().clear();
            return;
        case OWLPackage.COMPLEMENT_CLASS__SUB_CLASS:
            getSubClass().clear();
            return;
        case OWLPackage.COMPLEMENT_CLASS__OWNED_PROPERTY:
            getOwnedProperty().clear();
            return;
        case OWLPackage.COMPLEMENT_CLASS__RANGED_BY_PROPERTY:
            getRangedByProperty().clear();
            return;
        case OWLPackage.COMPLEMENT_CLASS__INSTANCE:
            getInstance().clear();
            return;
        case OWLPackage.COMPLEMENT_CLASS__DEPRECATED:
            setDeprecated(DEPRECATED_EDEFAULT);
            return;
        case OWLPackage.COMPLEMENT_CLASS__INV_OWL_EQUIVALENT_CLASS:
            getInvOWLEquivalentClass().clear();
            return;
        case OWLPackage.COMPLEMENT_CLASS__OWL_EQUIVALENT_CLASS:
            getOWLEquivalentClass().clear();
            return;
        case OWLPackage.COMPLEMENT_CLASS__OWL_DISJOINT_WITH:
            getOWLDisjointWith().clear();
            return;
        case OWLPackage.COMPLEMENT_CLASS__INV_OWL_DISJOINT_WITH:
            getInvOWLDisjointWith().clear();
            return;
        case OWLPackage.COMPLEMENT_CLASS__REF_BY_INTERSECTION_CLASS:
            getRefByIntersectionClass().clear();
            return;
        case OWLPackage.COMPLEMENT_CLASS__REF_BY_UNION_CLASS:
            getRefByUnionClass().clear();
            return;
        case OWLPackage.COMPLEMENT_CLASS__INV_OWL_COMPLEMENT_OF:
            getInvOWLComplementOf().clear();
            return;
        case OWLPackage.COMPLEMENT_CLASS__OWL_COMPLEMENT_OF:
            setOWLComplementOf((OWLClass) null);
            return;
        }
        eDynamicUnset(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean eIsSet(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case OWLPackage.COMPLEMENT_CLASS__LOCAL_NAME:
            return LOCAL_NAME_EDEFAULT == null ? localName != null
                    : !LOCAL_NAME_EDEFAULT.equals(localName);
        case OWLPackage.COMPLEMENT_CLASS__URI:
            return URI_EDEFAULT == null ? getURI() != null : !URI_EDEFAULT
                    .equals(getURI());
        case OWLPackage.COMPLEMENT_CLASS__SUBJECT_STATEMENT:
            return subjectStatement != null && !subjectStatement.isEmpty();
        case OWLPackage.COMPLEMENT_CLASS__OBJECT_STATEMENT:
            return objectStatement != null && !objectStatement.isEmpty();
        case OWLPackage.COMPLEMENT_CLASS__RDFS_IS_DEFINED_BY:
            return rdfsIsDefinedBy != null && !rdfsIsDefinedBy.isEmpty();
        case OWLPackage.COMPLEMENT_CLASS__RDF_VALUE:
            return rdfValue != null && !rdfValue.isEmpty();
        case OWLPackage.COMPLEMENT_CLASS__RDFS_SEE_ALSO:
            return rdfsSeeAlso != null && !rdfsSeeAlso.isEmpty();
        case OWLPackage.COMPLEMENT_CLASS__RDF_TYPE:
            return rdfType != null && !rdfType.isEmpty();
        case OWLPackage.COMPLEMENT_CLASS__RDFS_MEMBER:
            return rdfsMember != null && !rdfsMember.isEmpty();
        case OWLPackage.COMPLEMENT_CLASS__PREDICATE_STATEMENT:
            return predicateStatement != null && !predicateStatement.isEmpty();
        case OWLPackage.COMPLEMENT_CLASS__RDFS_COMMENT:
            return rdfsComment != null && !rdfsComment.isEmpty();
        case OWLPackage.COMPLEMENT_CLASS__RDFS_LABEL:
            return rdfsLabel != null && !rdfsLabel.isEmpty();
        case OWLPackage.COMPLEMENT_CLASS__NAMESPACE:
            return namespace != null;
        case OWLPackage.COMPLEMENT_CLASS__REF_BY_AVF_RESTRICTION:
            return refByAVFRestriction != null
                   && !refByAVFRestriction.isEmpty();
        case OWLPackage.COMPLEMENT_CLASS__REF_BY_SVF_RESTRICTION:
            return refBySVFRestriction != null
                   && !refBySVFRestriction.isEmpty();
        case OWLPackage.COMPLEMENT_CLASS__RDFS_SUB_CLASS_OF:
            return rdfsSubClassOf != null && !rdfsSubClassOf.isEmpty();
        case OWLPackage.COMPLEMENT_CLASS__SUB_CLASS:
            return subClass != null && !subClass.isEmpty();
        case OWLPackage.COMPLEMENT_CLASS__OWNED_PROPERTY:
            return ownedProperty != null && !ownedProperty.isEmpty();
        case OWLPackage.COMPLEMENT_CLASS__RANGED_BY_PROPERTY:
            return rangedByProperty != null && !rangedByProperty.isEmpty();
        case OWLPackage.COMPLEMENT_CLASS__INSTANCE:
            return instance != null && !instance.isEmpty();
        case OWLPackage.COMPLEMENT_CLASS__DEPRECATED:
            return DEPRECATED_EDEFAULT == null ? deprecated != null
                    : !DEPRECATED_EDEFAULT.equals(deprecated);
        case OWLPackage.COMPLEMENT_CLASS__INV_OWL_EQUIVALENT_CLASS:
            return invOWLEquivalentClass != null
                   && !invOWLEquivalentClass.isEmpty();
        case OWLPackage.COMPLEMENT_CLASS__OWL_EQUIVALENT_CLASS:
            return owlEquivalentClass != null && !owlEquivalentClass.isEmpty();
        case OWLPackage.COMPLEMENT_CLASS__OWL_DISJOINT_WITH:
            return owlDisjointWith != null && !owlDisjointWith.isEmpty();
        case OWLPackage.COMPLEMENT_CLASS__INV_OWL_DISJOINT_WITH:
            return invOWLDisjointWith != null && !invOWLDisjointWith.isEmpty();
        case OWLPackage.COMPLEMENT_CLASS__REF_BY_INTERSECTION_CLASS:
            return refByIntersectionClass != null
                   && !refByIntersectionClass.isEmpty();
        case OWLPackage.COMPLEMENT_CLASS__REF_BY_UNION_CLASS:
            return refByUnionClass != null && !refByUnionClass.isEmpty();
        case OWLPackage.COMPLEMENT_CLASS__INV_OWL_COMPLEMENT_OF:
            return invOWLComplementOf != null && !invOWLComplementOf.isEmpty();
        case OWLPackage.COMPLEMENT_CLASS__OWL_COMPLEMENT_OF:
            return owlComplementOf != null;
        }
        return eDynamicIsSet(eFeature);
    }

} //ComplementClassImpl
