/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved.   This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 *
 * $Id: IndividualImpl.java,v 1.1.1.1 2006/01/31 09:13:24 gxie Exp $
 */
package org.eclipse.eodm.owl.impl;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.eodm.owl.DatatypeSlot;
import org.eclipse.eodm.owl.Individual;
import org.eclipse.eodm.owl.OWLAllDifferent;
import org.eclipse.eodm.owl.OWLDatatypeProperty;
import org.eclipse.eodm.owl.OWLFactory;
import org.eclipse.eodm.owl.OWLObjectProperty;
import org.eclipse.eodm.owl.OWLPackage;
import org.eclipse.eodm.owl.ObjectSlot;
import org.eclipse.eodm.owl.Property;
import org.eclipse.eodm.rdfs.Namespace;
import org.eclipse.eodm.rdfs.RDFProperty;
import org.eclipse.eodm.rdfs.RDFSLiteral;
import org.eclipse.eodm.rdfs.RDFSResource;
import org.eclipse.eodm.rdfs.impl.RDFSResourceImpl;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Individual</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link org.eclipse.eodm.owl.impl.IndividualImpl#getOWLDifferentFrom <em>OWL Different From</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.impl.IndividualImpl#getInvOWLDifferentFrom <em>Inv OWL Different From</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.impl.IndividualImpl#getRefByOWLDistinctMembers <em>Ref By OWL Distinct Members</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.impl.IndividualImpl#getOWLSameAs <em>OWL Same As</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.impl.IndividualImpl#getInvOWLSameAs <em>Inv OWL Same As</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.impl.IndividualImpl#getDatatypeSlot <em>Datatype Slot</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.impl.IndividualImpl#getObjectSlot <em>Object Slot</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class IndividualImpl extends RDFSResourceImpl implements Individual {
    /**
     * The cached value of the '
     * {@link #getOWLDifferentFrom() <em>OWL Different From</em>}' reference
     * list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getOWLDifferentFrom()
     * @generated
     * @ordered
     */
    protected EList owlDifferentFrom = null;

    /**
     * The cached value of the '
     * {@link #getInvOWLDifferentFrom() <em>Inv OWL Different From</em>}'
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getInvOWLDifferentFrom()
     * @generated
     * @ordered
     */
    protected EList invOWLDifferentFrom = null;

    /**
     * The cached value of the '
     * {@link #getRefByOWLDistinctMembers() <em>Ref By OWL Distinct Members</em>}'
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getRefByOWLDistinctMembers()
     * @generated
     * @ordered
     */
    protected EList refByOWLDistinctMembers = null;

    /**
     * The cached value of the '{@link #getOWLSameAs() <em>OWL Same As</em>}'
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getOWLSameAs()
     * @generated
     * @ordered
     */
    protected EList owlSameAs = null;

    /**
     * The cached value of the '
     * {@link #getInvOWLSameAs() <em>Inv OWL Same As</em>}' reference list.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getInvOWLSameAs()
     * @generated
     * @ordered
     */
    protected EList invOWLSameAs = null;

    /**
     * The cached value of the '
     * {@link #getDatatypeSlot() <em>Datatype Slot</em>}' containment reference
     * list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getDatatypeSlot()
     * @generated
     * @ordered
     */
    protected EList datatypeSlot = null;

    /**
     * The cached value of the '{@link #getObjectSlot() <em>Object Slot</em>}'
     * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getObjectSlot()
     * @generated
     * @ordered
     */
    protected EList objectSlot = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected IndividualImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected EClass eStaticClass() {
        return OWLPackage.eINSTANCE.getIndividual();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EList getOWLDifferentFrom() {
        if (owlDifferentFrom == null) {
            owlDifferentFrom = new EObjectWithInverseResolvingEList.ManyInverse(
                    Individual.class, this,
                    OWLPackage.INDIVIDUAL__OWL_DIFFERENT_FROM,
                    OWLPackage.INDIVIDUAL__INV_OWL_DIFFERENT_FROM);
        }
        return owlDifferentFrom;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EList getInvOWLDifferentFrom() {
        if (invOWLDifferentFrom == null) {
            invOWLDifferentFrom = new EObjectWithInverseResolvingEList.ManyInverse(
                    Individual.class, this,
                    OWLPackage.INDIVIDUAL__INV_OWL_DIFFERENT_FROM,
                    OWLPackage.INDIVIDUAL__OWL_DIFFERENT_FROM);
        }
        return invOWLDifferentFrom;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EList getRefByOWLDistinctMembers() {
        if (refByOWLDistinctMembers == null) {
            refByOWLDistinctMembers = new EObjectWithInverseResolvingEList.ManyInverse(
                    OWLAllDifferent.class, this,
                    OWLPackage.INDIVIDUAL__REF_BY_OWL_DISTINCT_MEMBERS,
                    OWLPackage.OWL_ALL_DIFFERENT__OWL_DISTINCT_MEMBERS);
        }
        return refByOWLDistinctMembers;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EList getOWLSameAs() {
        if (owlSameAs == null) {
            owlSameAs = new EObjectWithInverseResolvingEList.ManyInverse(
                    Individual.class, this, OWLPackage.INDIVIDUAL__OWL_SAME_AS,
                    OWLPackage.INDIVIDUAL__INV_OWL_SAME_AS);
        }
        return owlSameAs;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EList getInvOWLSameAs() {
        if (invOWLSameAs == null) {
            invOWLSameAs = new EObjectWithInverseResolvingEList.ManyInverse(
                    Individual.class, this,
                    OWLPackage.INDIVIDUAL__INV_OWL_SAME_AS,
                    OWLPackage.INDIVIDUAL__OWL_SAME_AS);
        }
        return invOWLSameAs;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EList getDatatypeSlot() {
        if (datatypeSlot == null) {
            datatypeSlot = new EObjectContainmentWithInverseEList(
                    DatatypeSlot.class, this,
                    OWLPackage.INDIVIDUAL__DATATYPE_SLOT,
                    OWLPackage.DATATYPE_SLOT__INDIVIDUAL);
        }
        return datatypeSlot;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EList getObjectSlot() {
        if (objectSlot == null) {
            objectSlot = new EObjectContainmentWithInverseEList(
                    ObjectSlot.class, this, OWLPackage.INDIVIDUAL__OBJECT_SLOT,
                    OWLPackage.OBJECT_SLOT__INDIVIDUAL);
        }
        return objectSlot;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseAdd(InternalEObject otherEnd,
            int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case OWLPackage.INDIVIDUAL__SUBJECT_STATEMENT:
                return ((InternalEList) getSubjectStatement()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.INDIVIDUAL__OBJECT_STATEMENT:
                return ((InternalEList) getObjectStatement()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.INDIVIDUAL__RDF_TYPE:
                return ((InternalEList) getRDFType()).basicAdd(otherEnd, msgs);
            case OWLPackage.INDIVIDUAL__PREDICATE_STATEMENT:
                return ((InternalEList) getPredicateStatement()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.INDIVIDUAL__OWL_DIFFERENT_FROM:
                return ((InternalEList) getOWLDifferentFrom()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.INDIVIDUAL__INV_OWL_DIFFERENT_FROM:
                return ((InternalEList) getInvOWLDifferentFrom()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.INDIVIDUAL__REF_BY_OWL_DISTINCT_MEMBERS:
                return ((InternalEList) getRefByOWLDistinctMembers()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.INDIVIDUAL__OWL_SAME_AS:
                return ((InternalEList) getOWLSameAs())
                        .basicAdd(otherEnd, msgs);
            case OWLPackage.INDIVIDUAL__INV_OWL_SAME_AS:
                return ((InternalEList) getInvOWLSameAs()).basicAdd(otherEnd,
                        msgs);
            case OWLPackage.INDIVIDUAL__DATATYPE_SLOT:
                return ((InternalEList) getDatatypeSlot()).basicAdd(otherEnd,
                        msgs);
            case OWLPackage.INDIVIDUAL__OBJECT_SLOT:
                return ((InternalEList) getObjectSlot()).basicAdd(otherEnd,
                        msgs);
            default:
                return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
            }
        }
        if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
        return eBasicSetContainer(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseRemove(InternalEObject otherEnd,
            int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case OWLPackage.INDIVIDUAL__SUBJECT_STATEMENT:
                return ((InternalEList) getSubjectStatement()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.INDIVIDUAL__OBJECT_STATEMENT:
                return ((InternalEList) getObjectStatement()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.INDIVIDUAL__RDF_TYPE:
                return ((InternalEList) getRDFType()).basicRemove(otherEnd,
                        msgs);
            case OWLPackage.INDIVIDUAL__PREDICATE_STATEMENT:
                return ((InternalEList) getPredicateStatement()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.INDIVIDUAL__OWL_DIFFERENT_FROM:
                return ((InternalEList) getOWLDifferentFrom()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.INDIVIDUAL__INV_OWL_DIFFERENT_FROM:
                return ((InternalEList) getInvOWLDifferentFrom()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.INDIVIDUAL__REF_BY_OWL_DISTINCT_MEMBERS:
                return ((InternalEList) getRefByOWLDistinctMembers())
                        .basicRemove(otherEnd, msgs);
            case OWLPackage.INDIVIDUAL__OWL_SAME_AS:
                return ((InternalEList) getOWLSameAs()).basicRemove(otherEnd,
                        msgs);
            case OWLPackage.INDIVIDUAL__INV_OWL_SAME_AS:
                return ((InternalEList) getInvOWLSameAs()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.INDIVIDUAL__DATATYPE_SLOT:
                return ((InternalEList) getDatatypeSlot()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.INDIVIDUAL__OBJECT_SLOT:
                return ((InternalEList) getObjectSlot()).basicRemove(otherEnd,
                        msgs);
            default:
                return eDynamicInverseRemove(otherEnd, featureID, baseClass,
                        msgs);
            }
        }
        return eBasicSetContainer(null, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Object eGet(EStructuralFeature eFeature, boolean resolve) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case OWLPackage.INDIVIDUAL__LOCAL_NAME:
            return getLocalName();
        case OWLPackage.INDIVIDUAL__URI:
            return getURI();
        case OWLPackage.INDIVIDUAL__SUBJECT_STATEMENT:
            return getSubjectStatement();
        case OWLPackage.INDIVIDUAL__OBJECT_STATEMENT:
            return getObjectStatement();
        case OWLPackage.INDIVIDUAL__RDFS_IS_DEFINED_BY:
            return getRDFSIsDefinedBy();
        case OWLPackage.INDIVIDUAL__RDF_VALUE:
            return getRDFValue();
        case OWLPackage.INDIVIDUAL__RDFS_SEE_ALSO:
            return getRDFSSeeAlso();
        case OWLPackage.INDIVIDUAL__RDF_TYPE:
            return getRDFType();
        case OWLPackage.INDIVIDUAL__RDFS_MEMBER:
            return getRDFSMember();
        case OWLPackage.INDIVIDUAL__PREDICATE_STATEMENT:
            return getPredicateStatement();
        case OWLPackage.INDIVIDUAL__RDFS_COMMENT:
            return getRDFSComment();
        case OWLPackage.INDIVIDUAL__RDFS_LABEL:
            return getRDFSLabel();
        case OWLPackage.INDIVIDUAL__NAMESPACE:
            if (resolve)
                return getNamespace();
            return basicGetNamespace();
        case OWLPackage.INDIVIDUAL__OWL_DIFFERENT_FROM:
            return getOWLDifferentFrom();
        case OWLPackage.INDIVIDUAL__INV_OWL_DIFFERENT_FROM:
            return getInvOWLDifferentFrom();
        case OWLPackage.INDIVIDUAL__REF_BY_OWL_DISTINCT_MEMBERS:
            return getRefByOWLDistinctMembers();
        case OWLPackage.INDIVIDUAL__OWL_SAME_AS:
            return getOWLSameAs();
        case OWLPackage.INDIVIDUAL__INV_OWL_SAME_AS:
            return getInvOWLSameAs();
        case OWLPackage.INDIVIDUAL__DATATYPE_SLOT:
            return getDatatypeSlot();
        case OWLPackage.INDIVIDUAL__OBJECT_SLOT:
            return getObjectSlot();
        }
        return eDynamicGet(eFeature, resolve);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eSet(EStructuralFeature eFeature, Object newValue) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case OWLPackage.INDIVIDUAL__LOCAL_NAME:
            setLocalName((String) newValue);
            return;
        case OWLPackage.INDIVIDUAL__SUBJECT_STATEMENT:
            getSubjectStatement().clear();
            getSubjectStatement().addAll((Collection) newValue);
            return;
        case OWLPackage.INDIVIDUAL__OBJECT_STATEMENT:
            getObjectStatement().clear();
            getObjectStatement().addAll((Collection) newValue);
            return;
        case OWLPackage.INDIVIDUAL__RDFS_IS_DEFINED_BY:
            getRDFSIsDefinedBy().clear();
            getRDFSIsDefinedBy().addAll((Collection) newValue);
            return;
        case OWLPackage.INDIVIDUAL__RDF_VALUE:
            getRDFValue().clear();
            getRDFValue().addAll((Collection) newValue);
            return;
        case OWLPackage.INDIVIDUAL__RDFS_SEE_ALSO:
            getRDFSSeeAlso().clear();
            getRDFSSeeAlso().addAll((Collection) newValue);
            return;
        case OWLPackage.INDIVIDUAL__RDF_TYPE:
            getRDFType().clear();
            getRDFType().addAll((Collection) newValue);
            return;
        case OWLPackage.INDIVIDUAL__RDFS_MEMBER:
            getRDFSMember().clear();
            getRDFSMember().addAll((Collection) newValue);
            return;
        case OWLPackage.INDIVIDUAL__PREDICATE_STATEMENT:
            getPredicateStatement().clear();
            getPredicateStatement().addAll((Collection) newValue);
            return;
        case OWLPackage.INDIVIDUAL__RDFS_COMMENT:
            getRDFSComment().clear();
            getRDFSComment().addAll((Collection) newValue);
            return;
        case OWLPackage.INDIVIDUAL__RDFS_LABEL:
            getRDFSLabel().clear();
            getRDFSLabel().addAll((Collection) newValue);
            return;
        case OWLPackage.INDIVIDUAL__NAMESPACE:
            setNamespace((Namespace) newValue);
            return;
        case OWLPackage.INDIVIDUAL__OWL_DIFFERENT_FROM:
            getOWLDifferentFrom().clear();
            getOWLDifferentFrom().addAll((Collection) newValue);
            return;
        case OWLPackage.INDIVIDUAL__INV_OWL_DIFFERENT_FROM:
            getInvOWLDifferentFrom().clear();
            getInvOWLDifferentFrom().addAll((Collection) newValue);
            return;
        case OWLPackage.INDIVIDUAL__REF_BY_OWL_DISTINCT_MEMBERS:
            getRefByOWLDistinctMembers().clear();
            getRefByOWLDistinctMembers().addAll((Collection) newValue);
            return;
        case OWLPackage.INDIVIDUAL__OWL_SAME_AS:
            getOWLSameAs().clear();
            getOWLSameAs().addAll((Collection) newValue);
            return;
        case OWLPackage.INDIVIDUAL__INV_OWL_SAME_AS:
            getInvOWLSameAs().clear();
            getInvOWLSameAs().addAll((Collection) newValue);
            return;
        case OWLPackage.INDIVIDUAL__DATATYPE_SLOT:
            getDatatypeSlot().clear();
            getDatatypeSlot().addAll((Collection) newValue);
            return;
        case OWLPackage.INDIVIDUAL__OBJECT_SLOT:
            getObjectSlot().clear();
            getObjectSlot().addAll((Collection) newValue);
            return;
        }
        eDynamicSet(eFeature, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eUnset(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case OWLPackage.INDIVIDUAL__LOCAL_NAME:
            setLocalName(LOCAL_NAME_EDEFAULT);
            return;
        case OWLPackage.INDIVIDUAL__SUBJECT_STATEMENT:
            getSubjectStatement().clear();
            return;
        case OWLPackage.INDIVIDUAL__OBJECT_STATEMENT:
            getObjectStatement().clear();
            return;
        case OWLPackage.INDIVIDUAL__RDFS_IS_DEFINED_BY:
            getRDFSIsDefinedBy().clear();
            return;
        case OWLPackage.INDIVIDUAL__RDF_VALUE:
            getRDFValue().clear();
            return;
        case OWLPackage.INDIVIDUAL__RDFS_SEE_ALSO:
            getRDFSSeeAlso().clear();
            return;
        case OWLPackage.INDIVIDUAL__RDF_TYPE:
            getRDFType().clear();
            return;
        case OWLPackage.INDIVIDUAL__RDFS_MEMBER:
            getRDFSMember().clear();
            return;
        case OWLPackage.INDIVIDUAL__PREDICATE_STATEMENT:
            getPredicateStatement().clear();
            return;
        case OWLPackage.INDIVIDUAL__RDFS_COMMENT:
            getRDFSComment().clear();
            return;
        case OWLPackage.INDIVIDUAL__RDFS_LABEL:
            getRDFSLabel().clear();
            return;
        case OWLPackage.INDIVIDUAL__NAMESPACE:
            setNamespace((Namespace) null);
            return;
        case OWLPackage.INDIVIDUAL__OWL_DIFFERENT_FROM:
            getOWLDifferentFrom().clear();
            return;
        case OWLPackage.INDIVIDUAL__INV_OWL_DIFFERENT_FROM:
            getInvOWLDifferentFrom().clear();
            return;
        case OWLPackage.INDIVIDUAL__REF_BY_OWL_DISTINCT_MEMBERS:
            getRefByOWLDistinctMembers().clear();
            return;
        case OWLPackage.INDIVIDUAL__OWL_SAME_AS:
            getOWLSameAs().clear();
            return;
        case OWLPackage.INDIVIDUAL__INV_OWL_SAME_AS:
            getInvOWLSameAs().clear();
            return;
        case OWLPackage.INDIVIDUAL__DATATYPE_SLOT:
            getDatatypeSlot().clear();
            return;
        case OWLPackage.INDIVIDUAL__OBJECT_SLOT:
            getObjectSlot().clear();
            return;
        }
        eDynamicUnset(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean eIsSet(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case OWLPackage.INDIVIDUAL__LOCAL_NAME:
            return LOCAL_NAME_EDEFAULT == null ? localName != null
                    : !LOCAL_NAME_EDEFAULT.equals(localName);
        case OWLPackage.INDIVIDUAL__URI:
            return URI_EDEFAULT == null ? getURI() != null : !URI_EDEFAULT
                    .equals(getURI());
        case OWLPackage.INDIVIDUAL__SUBJECT_STATEMENT:
            return subjectStatement != null && !subjectStatement.isEmpty();
        case OWLPackage.INDIVIDUAL__OBJECT_STATEMENT:
            return objectStatement != null && !objectStatement.isEmpty();
        case OWLPackage.INDIVIDUAL__RDFS_IS_DEFINED_BY:
            return rdfsIsDefinedBy != null && !rdfsIsDefinedBy.isEmpty();
        case OWLPackage.INDIVIDUAL__RDF_VALUE:
            return rdfValue != null && !rdfValue.isEmpty();
        case OWLPackage.INDIVIDUAL__RDFS_SEE_ALSO:
            return rdfsSeeAlso != null && !rdfsSeeAlso.isEmpty();
        case OWLPackage.INDIVIDUAL__RDF_TYPE:
            return rdfType != null && !rdfType.isEmpty();
        case OWLPackage.INDIVIDUAL__RDFS_MEMBER:
            return rdfsMember != null && !rdfsMember.isEmpty();
        case OWLPackage.INDIVIDUAL__PREDICATE_STATEMENT:
            return predicateStatement != null && !predicateStatement.isEmpty();
        case OWLPackage.INDIVIDUAL__RDFS_COMMENT:
            return rdfsComment != null && !rdfsComment.isEmpty();
        case OWLPackage.INDIVIDUAL__RDFS_LABEL:
            return rdfsLabel != null && !rdfsLabel.isEmpty();
        case OWLPackage.INDIVIDUAL__NAMESPACE:
            return namespace != null;
        case OWLPackage.INDIVIDUAL__OWL_DIFFERENT_FROM:
            return owlDifferentFrom != null && !owlDifferentFrom.isEmpty();
        case OWLPackage.INDIVIDUAL__INV_OWL_DIFFERENT_FROM:
            return invOWLDifferentFrom != null
                   && !invOWLDifferentFrom.isEmpty();
        case OWLPackage.INDIVIDUAL__REF_BY_OWL_DISTINCT_MEMBERS:
            return refByOWLDistinctMembers != null
                   && !refByOWLDistinctMembers.isEmpty();
        case OWLPackage.INDIVIDUAL__OWL_SAME_AS:
            return owlSameAs != null && !owlSameAs.isEmpty();
        case OWLPackage.INDIVIDUAL__INV_OWL_SAME_AS:
            return invOWLSameAs != null && !invOWLSameAs.isEmpty();
        case OWLPackage.INDIVIDUAL__DATATYPE_SLOT:
            return datatypeSlot != null && !datatypeSlot.isEmpty();
        case OWLPackage.INDIVIDUAL__OBJECT_SLOT:
            return objectSlot != null && !objectSlot.isEmpty();
        }
        return eDynamicIsSet(eFeature);
    }
    
    /* (non-Javadoc)
     * @see org.eclipse.rdfs.RDFSResource#getPropertyValues(org.eclipse.rdfs.RDFProperty)
     */
    public List getPropertyValues(RDFProperty property){
        // check input param
        if ((property == null) ||
                !((property instanceof OWLDatatypeProperty) || (property instanceof OWLObjectProperty)))
            return null;
        
        //iterate the DatatypeSlot and ObjectSlot to find its property values
        if (property instanceof OWLDatatypeProperty){
            DatatypeSlot slot = null;
            for (Iterator iter = this.getDatatypeSlot().iterator(); iter.hasNext();) {
                slot = (DatatypeSlot) iter.next();
                if (slot.getProperty().equals(property))
                    //if subject and predicate match
                    return slot.getContent();
            }            
        }
        
        if (property instanceof OWLObjectProperty){
            ObjectSlot slot = null;
            for (Iterator iter = this.getObjectSlot().iterator(); iter.hasNext();) {
                slot = (ObjectSlot) iter.next();
                if (slot.getProperty().equals(property))
                    //if subject and predicate match
                    return slot.getContent();
            }            
        }

        return null;
    }
    
    /* (non-Javadoc)
     * @see org.eclipse.rdfs.RDFSResource#addPropertyValue(org.eclipse.rdfs.RDFProperty, org.eclipse.rdfs.RDFSResource)
     */
    public boolean addPropertyValue(RDFProperty property, RDFSResource resource) {
        // check input param
        if ((property == null)
                || !((property instanceof OWLDatatypeProperty) || (property instanceof OWLObjectProperty))
            	|| !((resource instanceof Individual) || (resource instanceof RDFSLiteral)))
            return false;
        
        //if value already exist
        List values = this.getPropertyValues(property);
        if (values != null)
            if (values.contains(resource))
                return false;
        OWLFactory owlFactory = OWLFactory.eINSTANCE;
        
       // create DatatypeSlot and ObjectSlot
       if (property instanceof OWLDatatypeProperty){
           DatatypeSlot slot = (DatatypeSlot)getSlot((Property)property);
           //if it is the new slot for this datatype property
           if (slot == null){
               slot = owlFactory.createDatatypeSlot(this, (OWLDatatypeProperty)property, (RDFSLiteral)resource);
           }else{
               // if DatatypeSlot already exists
               slot.getContent().add(resource);
           }
           return true;           
       }else{
           ObjectSlot slot = (ObjectSlot)getSlot((Property)property);
           //if it is the new slot for this object property
           if (slot == null){
               slot = owlFactory.createObjectSlot(this, (OWLObjectProperty)property, (Individual)resource);
           }else{
               // if ObjectSlot already exists
               slot.getContent().add(resource);
           }
           return true;
       }
    }
    
    /**
     * get DatatypeSlot or ObjectSlot that the property involves
     * @param property
     * @return
     */
    private EObject getSlot(Property property){
        
        if (property instanceof OWLDatatypeProperty){
            DatatypeSlot slot = null;
            for (Iterator iter = this.getDatatypeSlot().iterator(); iter.hasNext();) {
                slot = (DatatypeSlot) iter.next();
                if (slot.getProperty().equals(property))
                    //if subject and predicate match
                    return slot;
            }            
        }
        
        if (property instanceof OWLObjectProperty){
            ObjectSlot slot = null;
            for (Iterator iter = this.getObjectSlot().iterator(); iter.hasNext();) {
                slot = (ObjectSlot) iter.next();
                if (slot.getProperty().equals(property))
                    //if subject and predicate match
                    return slot;
            }            
        }
        
        return null;
    }

} //IndividualImpl
