/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved.   This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 *
 * $Id: ObjectSlotImpl.java,v 1.1.1.1 2006/01/31 09:13:24 gxie Exp $
 */
package org.eclipse.eodm.owl.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.eodm.owl.Individual;
import org.eclipse.eodm.owl.OWLObjectProperty;
import org.eclipse.eodm.owl.OWLPackage;
import org.eclipse.eodm.owl.ObjectSlot;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Object Slot</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link org.eclipse.eodm.owl.impl.ObjectSlotImpl#getIndividual <em>Individual</em>}
 * </li>
 * <li>{@link org.eclipse.eodm.owl.impl.ObjectSlotImpl#getContent <em>Content</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.impl.ObjectSlotImpl#getProperty <em>Property</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class ObjectSlotImpl extends EObjectImpl implements ObjectSlot {
    /**
     * The cached value of the '{@link #getContent() <em>Content</em>}'
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getContent()
     * @generated
     * @ordered
     */
    protected EList content = null;

    /**
     * The cached value of the '{@link #getProperty() <em>Property</em>}'
     * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getProperty()
     * @generated
     * @ordered
     */
    protected OWLObjectProperty property = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected ObjectSlotImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected EClass eStaticClass() {
        return OWLPackage.eINSTANCE.getObjectSlot();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Individual getIndividual() {
        if (eContainerFeatureID != OWLPackage.OBJECT_SLOT__INDIVIDUAL)
            return null;
        return (Individual) eContainer;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setIndividual(Individual newIndividual) {
        if (newIndividual != eContainer
            || (eContainerFeatureID != OWLPackage.OBJECT_SLOT__INDIVIDUAL && newIndividual != null)) {
            if (EcoreUtil.isAncestor(this, newIndividual))
                throw new IllegalArgumentException(
                        "Recursive containment not allowed for " + toString());
            NotificationChain msgs = null;
            if (eContainer != null)
                msgs = eBasicRemoveFromContainer(msgs);
            if (newIndividual != null)
                msgs = ((InternalEObject) newIndividual).eInverseAdd(this,
                        OWLPackage.INDIVIDUAL__OBJECT_SLOT, Individual.class,
                        msgs);
            msgs = eBasicSetContainer((InternalEObject) newIndividual,
                    OWLPackage.OBJECT_SLOT__INDIVIDUAL, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    OWLPackage.OBJECT_SLOT__INDIVIDUAL, newIndividual,
                    newIndividual));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EList getContent() {
        if (content == null) {
            content = new EObjectResolvingEList(Individual.class, this,
                    OWLPackage.OBJECT_SLOT__CONTENT);
        }
        return content;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public OWLObjectProperty getProperty() {
        if (property != null && property.eIsProxy()) {
            OWLObjectProperty oldProperty = property;
            property = (OWLObjectProperty) eResolveProxy((InternalEObject) property);
            if (property != oldProperty) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE,
                            OWLPackage.OBJECT_SLOT__PROPERTY, oldProperty,
                            property));
            }
        }
        return property;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public OWLObjectProperty basicGetProperty() {
        return property;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setProperty(OWLObjectProperty newProperty) {
        OWLObjectProperty oldProperty = property;
        property = newProperty;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    OWLPackage.OBJECT_SLOT__PROPERTY, oldProperty, property));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseAdd(InternalEObject otherEnd,
            int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case OWLPackage.OBJECT_SLOT__INDIVIDUAL:
                if (eContainer != null)
                    msgs = eBasicRemoveFromContainer(msgs);
                return eBasicSetContainer(otherEnd,
                        OWLPackage.OBJECT_SLOT__INDIVIDUAL, msgs);
            default:
                return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
            }
        }
        if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
        return eBasicSetContainer(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseRemove(InternalEObject otherEnd,
            int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case OWLPackage.OBJECT_SLOT__INDIVIDUAL:
                return eBasicSetContainer(null,
                        OWLPackage.OBJECT_SLOT__INDIVIDUAL, msgs);
            default:
                return eDynamicInverseRemove(otherEnd, featureID, baseClass,
                        msgs);
            }
        }
        return eBasicSetContainer(null, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
        if (eContainerFeatureID >= 0) {
            switch (eContainerFeatureID) {
            case OWLPackage.OBJECT_SLOT__INDIVIDUAL:
                return ((InternalEObject) eContainer).eInverseRemove(this,
                        OWLPackage.INDIVIDUAL__OBJECT_SLOT, Individual.class,
                        msgs);
            default:
                return eDynamicBasicRemoveFromContainer(msgs);
            }
        }
        return ((InternalEObject) eContainer).eInverseRemove(this,
                EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Object eGet(EStructuralFeature eFeature, boolean resolve) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case OWLPackage.OBJECT_SLOT__INDIVIDUAL:
            return getIndividual();
        case OWLPackage.OBJECT_SLOT__CONTENT:
            return getContent();
        case OWLPackage.OBJECT_SLOT__PROPERTY:
            if (resolve)
                return getProperty();
            return basicGetProperty();
        }
        return eDynamicGet(eFeature, resolve);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eSet(EStructuralFeature eFeature, Object newValue) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case OWLPackage.OBJECT_SLOT__INDIVIDUAL:
            setIndividual((Individual) newValue);
            return;
        case OWLPackage.OBJECT_SLOT__CONTENT:
            getContent().clear();
            getContent().addAll((Collection) newValue);
            return;
        case OWLPackage.OBJECT_SLOT__PROPERTY:
            setProperty((OWLObjectProperty) newValue);
            return;
        }
        eDynamicSet(eFeature, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eUnset(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case OWLPackage.OBJECT_SLOT__INDIVIDUAL:
            setIndividual((Individual) null);
            return;
        case OWLPackage.OBJECT_SLOT__CONTENT:
            getContent().clear();
            return;
        case OWLPackage.OBJECT_SLOT__PROPERTY:
            setProperty((OWLObjectProperty) null);
            return;
        }
        eDynamicUnset(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean eIsSet(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case OWLPackage.OBJECT_SLOT__INDIVIDUAL:
            return getIndividual() != null;
        case OWLPackage.OBJECT_SLOT__CONTENT:
            return content != null && !content.isEmpty();
        case OWLPackage.OBJECT_SLOT__PROPERTY:
            return property != null;
        }
        return eDynamicIsSet(eFeature);
    }

} //ObjectSlotImpl
