/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 * 
 * $Id: SimpleReasonerFactory.java,v 1.1.1.1 2006/01/31 09:13:26 gxie Exp $
 */
package org.eclipse.eodm.owl.reasoner.simple;

import org.eclipse.eodm.owl.reasoner.OWLTaxonomyReasoner;
import org.eclipse.eodm.owl.reasoner.TaxonomyReasonerFactory;

/**
 * SimpleReasonerFactory
 * TODO Please add comments here.
 */
public class SimpleReasonerFactory implements TaxonomyReasonerFactory {

    /**
     * Get instance of SimpleReasonerFactory
     * 
     * @return instance of SimpleReasonerFactory
     */
    public static SimpleReasonerFactory instance() {
        return new SimpleReasonerFactory();
    }
    
    /* (non-Javadoc)
     * @see org.eclipse.owl.reasoner.TaxonomyReasonerFactory#createOWLTaxonmyReasoner()
     */
    public OWLTaxonomyReasoner createOWLTaxonmyReasoner() {
        return new OWLSimpleTBoxReaonerImpl();
    }

}
