/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved.   This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 *
 * $Id: RDFSFactory.java,v 1.1.1.1 2006/01/31 09:13:24 gxie Exp $
 */
package org.eclipse.eodm.rdfs;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc --> The <b>Factory </b> for the model. It provides a
 * create method for each non-abstract class of the model. <!-- end-user-doc -->
 * 
 * @see org.eclipse.eodm.rdfs.RDFSPackage
 * @generated
 */
public interface RDFSFactory extends EFactory {
    /**
     * The singleton instance of the factory. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    RDFSFactory eINSTANCE = new org.eclipse.eodm.rdfs.impl.RDFSFactoryImpl();

    /**
     * Returns a new object of class '<em>Resource</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Resource</em>'.
     * @generated
     */
    RDFSResource createRDFSResource();
    
    /**
     * @param ontology
     * @param localName
     * @param ns
     * @return
     */
    RDFSResource createRDFSResource(Ontology ontology, String localName, Namespace ns);
    
    /**
     * @param ontology
     * @param localName
     * @return
     */
    RDFSResource createRDFSResource(Ontology ontology, String localName);

    /**
     * Returns a new object of class '<em>Class</em>'. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Class</em>'.
     * @generated
     */
    RDFSClass createRDFSClass();
    
    /**
     * @param ontology
     * @param localName
     * @param ns
     * @return
     */
    RDFSClass createRDFSClass(Ontology ontology, String localName, Namespace ns);
    
    /**
     * @param ontology
     * @param localName
     * @return
     */
    RDFSClass createRDFSClass(Ontology ontology, String localName);

    /**
     * Returns a new object of class '<em>Literal</em>'. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Literal</em>'.
     * @generated
     */
    RDFSLiteral createRDFSLiteral();
    
    /**
     * @param ontology
     * @param lexicalForm
     * @return
     */
    RDFSLiteral createRDFSLiteral(Ontology ontology, String lexicalForm);

    /**
     * Returns a new object of class '<em>Datatype</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Datatype</em>'.
     * @generated
     */
    RDFSDatatype createRDFSDatatype();
    
    /**
     * @param ontology
     * @param localName
     * @param ns
     * @return
     */
    RDFSDatatype createRDFSDatatype(Ontology ontology, String localName, Namespace ns);
    
    /**
     * @param ontology
     * @param localName
     * @return
     */
    RDFSDatatype createRDFSDatatype(Ontology ontology, String localName);

    /**
     * Returns a new object of class '<em>RDFXML Literal</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>RDFXML Literal</em>'.
     * @generated
     */
    RDFXMLLiteral createRDFXMLLiteral();
    
    /**
     * @param ontology
     * @param lexicalForm
     * @param language
     * @return
     */
    RDFXMLLiteral createRDFXMLLiteral(Ontology ontology, String lexicalForm, String language);

    /**
     * Returns a new object of class '<em>RDF Property</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>RDF Property</em>'.
     * @generated
     */
    RDFProperty createRDFProperty();
    
    /**
     * @param ontology
     * @param localName
     * @param ns
     * @return
     */
    RDFProperty createRDFProperty(Ontology ontology, String localName, Namespace ns);
    
    /**
     * @param ontology
     * @param localName
     * @param ns
     * @param domain
     * @param range
     * @return
     */
    RDFProperty createRDFProperty(Ontology ontology, String localName, Namespace ns, RDFSClass domain, RDFSClass range);
    
    /**
     * @param ontology
     * @param localName
     * @return
     */
    RDFProperty createRDFProperty(Ontology ontology, String localName);
    
    /**
     * @param ontology
     * @param localName
     * @param domain
     * @param range
     * @return
     */
    RDFProperty createRDFProperty(Ontology ontology, String localName, RDFSClass domain, RDFSClass range);
    

    /**
     * Returns a new object of class '<em>RDF List</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>RDF List</em>'.
     * @generated
     */
    RDFList createRDFList();
    
    /**
     * @param ontology
     * @param localName
     * @param ns
     * @return
     */
    RDFList createRDFList(Ontology ontology, String localName, Namespace ns);
    
    /**
     * @param ontology
     * @param localName
     * @return
     */
    RDFList createRDFList(Ontology ontology, String localName);

    /**
     * Returns a new object of class '<em>Container</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Container</em>'.
     * @generated
     */
    RDFSContainer createRDFSContainer();
    
    /**
     * @param ontology
     * @param localName
     * @param ns
     * @return
     */
    RDFSContainer createRDFSContainer(Ontology ontology, String localName, Namespace ns);
    
    /**
     * @param ontology
     * @param localName
     * @return
     */
    RDFSContainer createRDFSContainer(Ontology ontology, String localName);

    /**
     * Returns a new object of class '<em>RDF Alt</em>'. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>RDF Alt</em>'.
     * @generated
     */
    RDFAlt createRDFAlt();
    
    /**
     * @param ontology
     * @param localName
     * @param ns
     * @return
     */
    RDFAlt createRDFAlt(Ontology ontology, String localName, Namespace ns);
    
    /**
     * @param ontology
     * @param localName
     * @return
     */
    RDFAlt createRDFAlt(Ontology ontology, String localName);

    /**
     * Returns a new object of class '<em>RDF Bag</em>'. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>RDF Bag</em>'.
     * @generated
     */
    RDFBag createRDFBag();
    
    /**
     * @param ontology
     * @param localName
     * @param ns
     * @return
     */
    RDFBag createRDFBag(Ontology ontology, String localName, Namespace ns);
    
    /**
     * @param ontology
     * @param localName
     * @return
     */
    RDFBag createRDFBag(Ontology ontology, String localName);

    /**
     * Returns a new object of class '<em>eq</em>'. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>eq</em>'.
     * @generated
     */
    RDFSeq createRDFSeq();
    
    /**
     * @param ontology
     * @param localName
     * @param ns
     * @return
     */
    RDFSeq createRDFSeq(Ontology ontology, String localName, Namespace ns);
    
    /**
     * @param ontology
     * @param localName
     * @return
     */
    RDFSeq createRDFSeq(Ontology ontology, String localName);

    /**
     * Returns a new object of class '<em>Container Membership Property</em>'.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Container Membership Property</em>'.
     * @generated
     */
    RDFSContainerMembershipProperty createRDFSContainerMembershipProperty();

    /**
     * Returns a new object of class '<em>tatement</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>tatement</em>'.
     * @generated
     */
    RDFStatement createRDFStatement();
    
    /**
     * @param ontology
     * @param subject
     * @param object
     * @param predicate
     * @return
     */
    RDFStatement createRDFStatement(Ontology ontology, RDFSResource subject, RDFSResource predicate, RDFSResource object);

    /**
     * Returns a new object of class '<em>Ontology</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Ontology</em>'.
     * @generated
     */
    Ontology createOntology();
    
    /**
     * @param localName
     * @return
     */
    Ontology createOntology(String localName);

    /**
     * Returns a new object of class '<em>Plain Literal</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Plain Literal</em>'.
     * @generated
     */
    PlainLiteral createPlainLiteral();
    
    /**
     * @param ontology
     * @param lexicalForm
     * @param language
     * @return
     */
    PlainLiteral createPlainLiteral(Ontology ontology, String lexicalForm, String language);
    

    /**
     * Returns a new object of class '<em>Typed Literal</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Typed Literal</em>'.
     * @generated
     */
    TypedLiteral createTypedLiteral();
    
    /**
     * @param ontology
     * @param lexicalForm
     * @param dataType
     * @return
     */
    TypedLiteral createTypedLiteral(Ontology ontology, String lexicalForm, RDFSDatatype dataType);

    /**
     * Returns a new object of class '<em>Namespace</em>'. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return a new object of class '<em>Namespace</em>'.
     * @generated
     */
    Namespace createNamespace();
    
    /**
     * @param ontology
     * @param name
     * @param uri
     * @return
     */
    Namespace createNamespace(Ontology ontology, String name, String uri);

    /**
     * Returns the package supported by this factory. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the package supported by this factory.
     * @generated
     */
    RDFSPackage getRDFSPackage();

} //RdfsFactory
