/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved.   This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 *
 * $Id: RDFStatement.java,v 1.1.1.1 2006/01/31 09:13:25 gxie Exp $
 */
package org.eclipse.eodm.rdfs;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>RDF Statement</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link org.eclipse.eodm.rdfs.RDFStatement#getRDFSubject <em>RDF Subject</em>}
 * </li>
 * <li>{@link org.eclipse.eodm.rdfs.RDFStatement#getRDFObject <em>RDF Object</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.rdfs.RDFStatement#getRDFPredicate <em>RDF Predicate</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @see org.eclipse.eodm.rdfs.RDFSPackage#getRDFStatement()
 * @model
 * @generated
 */
public interface RDFStatement extends RDFSResource {
    /**
     * Returns the value of the '<em><b>RDF Subject</b></em>' reference. It
     * is bidirectional and its opposite is '
     * {@link org.eclipse.eodm.rdfs.RDFSResource#getSubjectStatement <em>Subject Statement</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>RDF Subject</em>' reference.
     * @see #setRDFSubject(RDFSResource)
     * @see org.eclipse.eodm.rdfs.RDFSPackage#getRDFStatement_RDFSubject()
     * @see org.eclipse.eodm.rdfs.RDFSResource#getSubjectStatement
     * @model opposite="subjectStatement" required="true"
     * @generated
     */
    RDFSResource getRDFSubject();

    /**
     * Sets the value of the '
     * {@link org.eclipse.eodm.rdfs.RDFStatement#getRDFSubject <em>RDF Subject</em>}'
     * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value
     *            the new value of the '<em>RDF Subject</em>' reference.
     * @see #getRDFSubject()
     * @generated
     */
    void setRDFSubject(RDFSResource value);

    /**
     * Returns the value of the '<em><b>RDF Object</b></em>' reference. It
     * is bidirectional and its opposite is '
     * {@link org.eclipse.eodm.rdfs.RDFSResource#getObjectStatement <em>Object Statement</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>RDF Object</em>' reference.
     * @see #setRDFObject(RDFSResource)
     * @see org.eclipse.eodm.rdfs.RDFSPackage#getRDFStatement_RDFObject()
     * @see org.eclipse.eodm.rdfs.RDFSResource#getObjectStatement
     * @model opposite="objectStatement" required="true"
     * @generated
     */
    RDFSResource getRDFObject();

    /**
     * Sets the value of the '
     * {@link org.eclipse.eodm.rdfs.RDFStatement#getRDFObject <em>RDF Object</em>}'
     * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value
     *            the new value of the '<em>RDF Object</em>' reference.
     * @see #getRDFObject()
     * @generated
     */
    void setRDFObject(RDFSResource value);

    /**
     * Returns the value of the '<em><b>RDF Predicate</b></em>' reference.
     * It is bidirectional and its opposite is '
     * {@link org.eclipse.eodm.rdfs.RDFSResource#getPredicateStatement <em>Predicate Statement</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>RDF Predicate</em>' reference.
     * @see #setRDFPredicate(RDFSResource)
     * @see org.eclipse.eodm.rdfs.RDFSPackage#getRDFStatement_RDFPredicate()
     * @see org.eclipse.eodm.rdfs.RDFSResource#getPredicateStatement
     * @model opposite="predicateStatement" required="true"
     * @generated
     */
    RDFSResource getRDFPredicate();

    /**
     * Sets the value of the '
     * {@link org.eclipse.eodm.rdfs.RDFStatement#getRDFPredicate <em>RDF Predicate</em>}'
     * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value
     *            the new value of the '<em>RDF Predicate</em>' reference.
     * @see #getRDFPredicate()
     * @generated
     */
    void setRDFPredicate(RDFSResource value);

    /**
     * Decide whether a statement is a reification statement or just a normal
     * statement.
     * 
     * @return true if it is a reification
     */
    boolean isReified();

    /**
     * Sets the value of a statement's refied attribute
     * 
     * @param value
     *            a statement's refied attribute
     */

    void setReified(boolean value);

} // RDFStatement
