/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved.   This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 *
 * $Id: TypedLiteral.java,v 1.1.1.1 2006/01/31 09:13:24 gxie Exp $
 */
package org.eclipse.eodm.rdfs;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Typed Literal</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link org.eclipse.eodm.rdfs.TypedLiteral#getDatatype <em>Datatype</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @see org.eclipse.eodm.rdfs.RDFSPackage#getTypedLiteral()
 * @model
 * @generated
 */
public interface TypedLiteral extends RDFSLiteral {
    /**
     * Returns the value of the '<em><b>Datatype</b></em>' reference. <!--
     * begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Datatype</em>' reference.
     * @see #setDatatype(RDFSDatatype)
     * @see org.eclipse.eodm.rdfs.RDFSPackage#getTypedLiteral_Datatype()
     * @model required="true"
     * @generated
     */
    RDFSDatatype getDatatype();

    /**
     * Sets the value of the '
     * {@link org.eclipse.eodm.rdfs.TypedLiteral#getDatatype <em>Datatype</em>}'
     * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value
     *            the new value of the '<em>Datatype</em>' reference.
     * @see #getDatatype()
     * @generated
     */
    void setDatatype(RDFSDatatype value);

} // TypedLiteral
