/**
 * <copyright>
 * </copyright>
 *
 * $Id: OntologyImpl.java,v 1.1.1.1 2006/01/31 09:13:25 gxie Exp $
 */
package org.eclipse.eodm.rdfs.impl;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.eodm.rdfs.Namespace;
import org.eclipse.eodm.rdfs.Ontology;
import org.eclipse.eodm.rdfs.RDFProperty;
import org.eclipse.eodm.rdfs.RDFSClass;
import org.eclipse.eodm.rdfs.RDFSPackage;
import org.eclipse.eodm.rdfs.RDFSResource;
import org.eclipse.eodm.rdfs.RDFStatement;
import org.eclipse.eodm.rdfs.reasoner.RDFSReasoner;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Ontology</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link org.eclipse.eodm.rdfs.impl.OntologyImpl#getContains <em>Contains</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.rdfs.impl.OntologyImpl#getOwnedNamespace <em>Owned Namespace</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class OntologyImpl extends RDFSResourceImpl implements Ontology {
    /**
     * The cached value of the '{@link #getContains() <em>Contains</em>}'
     * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getContains()
     * @generated
     * @ordered
     */
    protected EList contains = null;

    /**
     * The cached value of the '
     * {@link #getOwnedNamespace() <em>Owned Namespace</em>}' containment
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getOwnedNamespace()
     * @generated
     * @ordered
     */
    protected EList ownedNamespace = null;

    /**
     * Comment for <code>RDFSReasoner</code>
     * 
     * the RDFSReasoner that is associated with this RDFDescription
     */
    protected RDFSReasoner reasoner = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected OntologyImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected EClass eStaticClass() {
        return RDFSPackage.eINSTANCE.getOntology();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EList getContains() {
        if (contains == null) {
            contains = new EObjectContainmentEList(RDFSResource.class, this,
                    RDFSPackage.ONTOLOGY__CONTAINS);
        }
        return contains;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EList getOwnedNamespace() {
        if (ownedNamespace == null) {
            ownedNamespace = new EObjectContainmentEList(Namespace.class, this,
                    RDFSPackage.ONTOLOGY__OWNED_NAMESPACE);
        }
        return ownedNamespace;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseAdd(InternalEObject otherEnd,
            int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case RDFSPackage.ONTOLOGY__SUBJECT_STATEMENT:
                return ((InternalEList) getSubjectStatement()).basicAdd(
                        otherEnd, msgs);
            case RDFSPackage.ONTOLOGY__OBJECT_STATEMENT:
                return ((InternalEList) getObjectStatement()).basicAdd(
                        otherEnd, msgs);
            case RDFSPackage.ONTOLOGY__RDF_TYPE:
                return ((InternalEList) getRDFType()).basicAdd(otherEnd, msgs);
            case RDFSPackage.ONTOLOGY__PREDICATE_STATEMENT:
                return ((InternalEList) getPredicateStatement()).basicAdd(
                        otherEnd, msgs);
            default:
                return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
            }
        }
        if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
        return eBasicSetContainer(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseRemove(InternalEObject otherEnd,
            int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case RDFSPackage.ONTOLOGY__SUBJECT_STATEMENT:
                return ((InternalEList) getSubjectStatement()).basicRemove(
                        otherEnd, msgs);
            case RDFSPackage.ONTOLOGY__OBJECT_STATEMENT:
                return ((InternalEList) getObjectStatement()).basicRemove(
                        otherEnd, msgs);
            case RDFSPackage.ONTOLOGY__RDF_TYPE:
                return ((InternalEList) getRDFType()).basicRemove(otherEnd,
                        msgs);
            case RDFSPackage.ONTOLOGY__PREDICATE_STATEMENT:
                return ((InternalEList) getPredicateStatement()).basicRemove(
                        otherEnd, msgs);
            case RDFSPackage.ONTOLOGY__CONTAINS:
                return ((InternalEList) getContains()).basicRemove(otherEnd,
                        msgs);
            case RDFSPackage.ONTOLOGY__OWNED_NAMESPACE:
                return ((InternalEList) getOwnedNamespace()).basicRemove(
                        otherEnd, msgs);
            default:
                return eDynamicInverseRemove(otherEnd, featureID, baseClass,
                        msgs);
            }
        }
        return eBasicSetContainer(null, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Object eGet(EStructuralFeature eFeature, boolean resolve) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case RDFSPackage.ONTOLOGY__LOCAL_NAME:
            return getLocalName();
        case RDFSPackage.ONTOLOGY__URI:
            return getURI();
        case RDFSPackage.ONTOLOGY__SUBJECT_STATEMENT:
            return getSubjectStatement();
        case RDFSPackage.ONTOLOGY__OBJECT_STATEMENT:
            return getObjectStatement();
        case RDFSPackage.ONTOLOGY__RDFS_IS_DEFINED_BY:
            return getRDFSIsDefinedBy();
        case RDFSPackage.ONTOLOGY__RDF_VALUE:
            return getRDFValue();
        case RDFSPackage.ONTOLOGY__RDFS_SEE_ALSO:
            return getRDFSSeeAlso();
        case RDFSPackage.ONTOLOGY__RDF_TYPE:
            return getRDFType();
        case RDFSPackage.ONTOLOGY__RDFS_MEMBER:
            return getRDFSMember();
        case RDFSPackage.ONTOLOGY__PREDICATE_STATEMENT:
            return getPredicateStatement();
        case RDFSPackage.ONTOLOGY__RDFS_COMMENT:
            return getRDFSComment();
        case RDFSPackage.ONTOLOGY__RDFS_LABEL:
            return getRDFSLabel();
        case RDFSPackage.ONTOLOGY__NAMESPACE:
            if (resolve)
                return getNamespace();
            return basicGetNamespace();
        case RDFSPackage.ONTOLOGY__CONTAINS:
            return getContains();
        case RDFSPackage.ONTOLOGY__OWNED_NAMESPACE:
            return getOwnedNamespace();
        }
        return eDynamicGet(eFeature, resolve);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eSet(EStructuralFeature eFeature, Object newValue) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case RDFSPackage.ONTOLOGY__LOCAL_NAME:
            setLocalName((String) newValue);
            return;
        case RDFSPackage.ONTOLOGY__SUBJECT_STATEMENT:
            getSubjectStatement().clear();
            getSubjectStatement().addAll((Collection) newValue);
            return;
        case RDFSPackage.ONTOLOGY__OBJECT_STATEMENT:
            getObjectStatement().clear();
            getObjectStatement().addAll((Collection) newValue);
            return;
        case RDFSPackage.ONTOLOGY__RDFS_IS_DEFINED_BY:
            getRDFSIsDefinedBy().clear();
            getRDFSIsDefinedBy().addAll((Collection) newValue);
            return;
        case RDFSPackage.ONTOLOGY__RDF_VALUE:
            getRDFValue().clear();
            getRDFValue().addAll((Collection) newValue);
            return;
        case RDFSPackage.ONTOLOGY__RDFS_SEE_ALSO:
            getRDFSSeeAlso().clear();
            getRDFSSeeAlso().addAll((Collection) newValue);
            return;
        case RDFSPackage.ONTOLOGY__RDF_TYPE:
            getRDFType().clear();
            getRDFType().addAll((Collection) newValue);
            return;
        case RDFSPackage.ONTOLOGY__RDFS_MEMBER:
            getRDFSMember().clear();
            getRDFSMember().addAll((Collection) newValue);
            return;
        case RDFSPackage.ONTOLOGY__PREDICATE_STATEMENT:
            getPredicateStatement().clear();
            getPredicateStatement().addAll((Collection) newValue);
            return;
        case RDFSPackage.ONTOLOGY__RDFS_COMMENT:
            getRDFSComment().clear();
            getRDFSComment().addAll((Collection) newValue);
            return;
        case RDFSPackage.ONTOLOGY__RDFS_LABEL:
            getRDFSLabel().clear();
            getRDFSLabel().addAll((Collection) newValue);
            return;
        case RDFSPackage.ONTOLOGY__NAMESPACE:
            setNamespace((Namespace) newValue);
            return;
        case RDFSPackage.ONTOLOGY__CONTAINS:
            getContains().clear();
            getContains().addAll((Collection) newValue);
            return;
        case RDFSPackage.ONTOLOGY__OWNED_NAMESPACE:
            getOwnedNamespace().clear();
            getOwnedNamespace().addAll((Collection) newValue);
            return;
        }
        eDynamicSet(eFeature, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eUnset(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case RDFSPackage.ONTOLOGY__LOCAL_NAME:
            setLocalName(LOCAL_NAME_EDEFAULT);
            return;
        case RDFSPackage.ONTOLOGY__SUBJECT_STATEMENT:
            getSubjectStatement().clear();
            return;
        case RDFSPackage.ONTOLOGY__OBJECT_STATEMENT:
            getObjectStatement().clear();
            return;
        case RDFSPackage.ONTOLOGY__RDFS_IS_DEFINED_BY:
            getRDFSIsDefinedBy().clear();
            return;
        case RDFSPackage.ONTOLOGY__RDF_VALUE:
            getRDFValue().clear();
            return;
        case RDFSPackage.ONTOLOGY__RDFS_SEE_ALSO:
            getRDFSSeeAlso().clear();
            return;
        case RDFSPackage.ONTOLOGY__RDF_TYPE:
            getRDFType().clear();
            return;
        case RDFSPackage.ONTOLOGY__RDFS_MEMBER:
            getRDFSMember().clear();
            return;
        case RDFSPackage.ONTOLOGY__PREDICATE_STATEMENT:
            getPredicateStatement().clear();
            return;
        case RDFSPackage.ONTOLOGY__RDFS_COMMENT:
            getRDFSComment().clear();
            return;
        case RDFSPackage.ONTOLOGY__RDFS_LABEL:
            getRDFSLabel().clear();
            return;
        case RDFSPackage.ONTOLOGY__NAMESPACE:
            setNamespace((Namespace) null);
            return;
        case RDFSPackage.ONTOLOGY__CONTAINS:
            getContains().clear();
            return;
        case RDFSPackage.ONTOLOGY__OWNED_NAMESPACE:
            getOwnedNamespace().clear();
            return;
        }
        eDynamicUnset(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean eIsSet(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case RDFSPackage.ONTOLOGY__LOCAL_NAME:
            return LOCAL_NAME_EDEFAULT == null ? localName != null
                    : !LOCAL_NAME_EDEFAULT.equals(localName);
        case RDFSPackage.ONTOLOGY__URI:
            return URI_EDEFAULT == null ? getURI() != null : !URI_EDEFAULT
                    .equals(getURI());
        case RDFSPackage.ONTOLOGY__SUBJECT_STATEMENT:
            return subjectStatement != null && !subjectStatement.isEmpty();
        case RDFSPackage.ONTOLOGY__OBJECT_STATEMENT:
            return objectStatement != null && !objectStatement.isEmpty();
        case RDFSPackage.ONTOLOGY__RDFS_IS_DEFINED_BY:
            return rdfsIsDefinedBy != null && !rdfsIsDefinedBy.isEmpty();
        case RDFSPackage.ONTOLOGY__RDF_VALUE:
            return rdfValue != null && !rdfValue.isEmpty();
        case RDFSPackage.ONTOLOGY__RDFS_SEE_ALSO:
            return rdfsSeeAlso != null && !rdfsSeeAlso.isEmpty();
        case RDFSPackage.ONTOLOGY__RDF_TYPE:
            return rdfType != null && !rdfType.isEmpty();
        case RDFSPackage.ONTOLOGY__RDFS_MEMBER:
            return rdfsMember != null && !rdfsMember.isEmpty();
        case RDFSPackage.ONTOLOGY__PREDICATE_STATEMENT:
            return predicateStatement != null && !predicateStatement.isEmpty();
        case RDFSPackage.ONTOLOGY__RDFS_COMMENT:
            return rdfsComment != null && !rdfsComment.isEmpty();
        case RDFSPackage.ONTOLOGY__RDFS_LABEL:
            return rdfsLabel != null && !rdfsLabel.isEmpty();
        case RDFSPackage.ONTOLOGY__NAMESPACE:
            return namespace != null;
        case RDFSPackage.ONTOLOGY__CONTAINS:
            return contains != null && !contains.isEmpty();
        case RDFSPackage.ONTOLOGY__OWNED_NAMESPACE:
            return ownedNamespace != null && !ownedNamespace.isEmpty();
        }
        return eDynamicIsSet(eFeature);
    }

    /**
     * Created on 2005-3-7 14:26:34 Author Gordon
     * 
     * Get associated reasoner
     * 
     * @return reasoner
     */
    public RDFSReasoner getReasoner() {
        return reasoner;
    }

    /**
     * Created on 2005-3-7 14:26:34 Author Gordon
     * 
     * Set associated reasoner
     * 
     * @param reasoner
     */
    public void bindReasoner(RDFSReasoner reasoner) {
        this.reasoner = reasoner;
    }

    public RDFSResource getContainedResource(Namespace namespace,
            String localName) {
        // if input params error
        if (localName == null)
            return null;

        RDFSResource resource = null;
        Namespace localSpace = null;

        // iterate the contained resources to find specific resource with name
        // as localName
        for (Iterator iter = this.getContains().iterator(); iter.hasNext();) {
            resource = (RDFSResource) iter.next();
            if (resource.getLocalName() == null)
                continue;
            // find the resource
            if (resource.getLocalName().equals(localName))
                // if namespace equals
                if (namespace != null) {
                    localSpace = (Namespace) resource.getNamespace();
                    if (localSpace != null)
                        if (localSpace.equals(namespace))
                            return resource;
                } else {
                    return resource;
                }
        }
        // if find nothing, return null
        return null;
    }

    public List getResourceList(Class resourceType) {
        // if input params error
        if (resourceType == null)
            return null;

        Vector resources = new Vector();
        Object obj = null;

        // iterate the contained resources to find specific resource list
        for (Iterator iter = this.getContains().iterator(); iter.hasNext();) {
            obj = iter.next();
            if (resourceType.isInstance(obj))
                resources.addElement(obj);
        }

        obj = null;
        return resources;
    }

    public void notifyChanged(Notification notification) {
        int type = notification.getEventType();

        switch (type) {
        case Notification.REMOVE:
            handleRemoveResource((RDFSResource) notification.getOldValue());
            break;
        default:
            break;
        }
    }

    public Notifier getTarget() {
        return notifier;
    }

    public void setTarget(Notifier newTarget) {
        notifier = newTarget;
    }

    public boolean isAdapterForType(Object type) {
        return false;
    }

    protected Notifier notifier = null;

    Vector stmts = new Vector();

    protected void handleRemoveResource(RDFSResource resource) {
        if (resource instanceof RDFStatement) {
            ((RDFStatement) resource).setRDFSubject(null);
            ((RDFStatement) resource).setRDFObject(null);
            ((RDFStatement) resource).setRDFPredicate(null);
        } else if (resource instanceof RDFSClass) {
            ((RDFSClass) resource).getSubClass().clear();
            ((RDFSClass) resource).getRDFSSubClassOf().clear();
            ((RDFSClass) resource).getOwnedProperty().clear();
            ((RDFSClass) resource).getRangedByProperty().clear();
            ((RDFSClass) resource).getInstance().clear();
        } else if (resource instanceof RDFProperty) {
            ((RDFProperty) resource).getSubProperty().clear();
            ((RDFProperty) resource).getRDFSSubPropertyOf().clear();
            ((RDFProperty) resource).getRDFSDomain().clear();
            ((RDFProperty) resource).getRDFSRange().clear();

            // remove statements last time
            stmts.clear();
            for (Iterator iter = ((RDFProperty) resource)
                    .getPredicateStatement().iterator(); iter.hasNext();) {
                stmts.add(iter.next());
            }

            ((RDFProperty) resource).getPredicateStatement().clear();
            for (Iterator iter = stmts.iterator(); iter.hasNext();) {
                this.getContains().remove(iter.next());
            }
        } else { // resource is a individual
            resource.getRDFType().clear();
            stmts.clear();
            for (Iterator iter = resource.getObjectStatement().iterator(); iter
                    .hasNext();) {
                stmts.add(iter.next());
            }
            resource.getObjectStatement().clear();

            for (Iterator iter = resource.getSubjectStatement().iterator(); iter
                    .hasNext();) {
                stmts.add(iter.next());
            }
            resource.getSubjectStatement().clear();

            for (Iterator iter = stmts.iterator(); iter.hasNext();) {
                this.getContains().remove(iter.next());
            }
        }
    }

} // OntologyImpl
