/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved.   This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 *
 * $Id: RDFListImpl.java,v 1.1.1.1 2006/01/31 09:13:25 gxie Exp $
 */
package org.eclipse.eodm.rdfs.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.eodm.rdfs.Namespace;
import org.eclipse.eodm.rdfs.RDFList;
import org.eclipse.eodm.rdfs.RDFSPackage;
import org.eclipse.eodm.rdfs.RDFSResource;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>RDF List</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link org.eclipse.eodm.rdfs.impl.RDFListImpl#getRDFRest <em>RDF Rest</em>}
 * </li>
 * <li>{@link org.eclipse.eodm.rdfs.impl.RDFListImpl#getRDFFirst <em>RDF First</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class RDFListImpl extends RDFSResourceImpl implements RDFList {
    /**
     * The cached value of the '{@link #getRDFRest() <em>RDF Rest</em>}'
     * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getRDFRest()
     * @generated
     * @ordered
     */
    protected RDFList rdfRest = null;

    /**
     * The cached value of the '{@link #getRDFFirst() <em>RDF First</em>}'
     * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getRDFFirst()
     * @generated
     * @ordered
     */
    protected RDFSResource rdfFirst = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected RDFListImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected EClass eStaticClass() {
        return RDFSPackage.eINSTANCE.getRDFList();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public RDFList getRDFRest() {
        if (rdfRest != null && rdfRest.eIsProxy()) {
            RDFList oldRDFRest = rdfRest;
            rdfRest = (RDFList) eResolveProxy((InternalEObject) rdfRest);
            if (rdfRest != oldRDFRest) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE,
                            RDFSPackage.RDF_LIST__RDF_REST, oldRDFRest, rdfRest));
            }
        }
        return rdfRest;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public RDFList basicGetRDFRest() {
        return rdfRest;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setRDFRest(RDFList newRDFRest) {
        RDFList oldRDFRest = rdfRest;
        rdfRest = newRDFRest;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    RDFSPackage.RDF_LIST__RDF_REST, oldRDFRest, rdfRest));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public RDFSResource getRDFFirst() {
        if (rdfFirst != null && rdfFirst.eIsProxy()) {
            RDFSResource oldRDFFirst = rdfFirst;
            rdfFirst = (RDFSResource) eResolveProxy((InternalEObject) rdfFirst);
            if (rdfFirst != oldRDFFirst) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE,
                            RDFSPackage.RDF_LIST__RDF_FIRST, oldRDFFirst,
                            rdfFirst));
            }
        }
        return rdfFirst;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public RDFSResource basicGetRDFFirst() {
        return rdfFirst;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setRDFFirst(RDFSResource newRDFFirst) {
        RDFSResource oldRDFFirst = rdfFirst;
        rdfFirst = newRDFFirst;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    RDFSPackage.RDF_LIST__RDF_FIRST, oldRDFFirst, rdfFirst));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseAdd(InternalEObject otherEnd,
            int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case RDFSPackage.RDF_LIST__SUBJECT_STATEMENT:
                return ((InternalEList) getSubjectStatement()).basicAdd(
                        otherEnd, msgs);
            case RDFSPackage.RDF_LIST__OBJECT_STATEMENT:
                return ((InternalEList) getObjectStatement()).basicAdd(
                        otherEnd, msgs);
            case RDFSPackage.RDF_LIST__RDF_TYPE:
                return ((InternalEList) getRDFType()).basicAdd(otherEnd, msgs);
            case RDFSPackage.RDF_LIST__PREDICATE_STATEMENT:
                return ((InternalEList) getPredicateStatement()).basicAdd(
                        otherEnd, msgs);
            default:
                return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
            }
        }
        if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
        return eBasicSetContainer(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseRemove(InternalEObject otherEnd,
            int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case RDFSPackage.RDF_LIST__SUBJECT_STATEMENT:
                return ((InternalEList) getSubjectStatement()).basicRemove(
                        otherEnd, msgs);
            case RDFSPackage.RDF_LIST__OBJECT_STATEMENT:
                return ((InternalEList) getObjectStatement()).basicRemove(
                        otherEnd, msgs);
            case RDFSPackage.RDF_LIST__RDF_TYPE:
                return ((InternalEList) getRDFType()).basicRemove(otherEnd,
                        msgs);
            case RDFSPackage.RDF_LIST__PREDICATE_STATEMENT:
                return ((InternalEList) getPredicateStatement()).basicRemove(
                        otherEnd, msgs);
            default:
                return eDynamicInverseRemove(otherEnd, featureID, baseClass,
                        msgs);
            }
        }
        return eBasicSetContainer(null, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Object eGet(EStructuralFeature eFeature, boolean resolve) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case RDFSPackage.RDF_LIST__LOCAL_NAME:
            return getLocalName();
        case RDFSPackage.RDF_LIST__URI:
            return getURI();
        case RDFSPackage.RDF_LIST__SUBJECT_STATEMENT:
            return getSubjectStatement();
        case RDFSPackage.RDF_LIST__OBJECT_STATEMENT:
            return getObjectStatement();
        case RDFSPackage.RDF_LIST__RDFS_IS_DEFINED_BY:
            return getRDFSIsDefinedBy();
        case RDFSPackage.RDF_LIST__RDF_VALUE:
            return getRDFValue();
        case RDFSPackage.RDF_LIST__RDFS_SEE_ALSO:
            return getRDFSSeeAlso();
        case RDFSPackage.RDF_LIST__RDF_TYPE:
            return getRDFType();
        case RDFSPackage.RDF_LIST__RDFS_MEMBER:
            return getRDFSMember();
        case RDFSPackage.RDF_LIST__PREDICATE_STATEMENT:
            return getPredicateStatement();
        case RDFSPackage.RDF_LIST__RDFS_COMMENT:
            return getRDFSComment();
        case RDFSPackage.RDF_LIST__RDFS_LABEL:
            return getRDFSLabel();
        case RDFSPackage.RDF_LIST__NAMESPACE:
            if (resolve)
                return getNamespace();
            return basicGetNamespace();
        case RDFSPackage.RDF_LIST__RDF_REST:
            if (resolve)
                return getRDFRest();
            return basicGetRDFRest();
        case RDFSPackage.RDF_LIST__RDF_FIRST:
            if (resolve)
                return getRDFFirst();
            return basicGetRDFFirst();
        }
        return eDynamicGet(eFeature, resolve);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eSet(EStructuralFeature eFeature, Object newValue) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case RDFSPackage.RDF_LIST__LOCAL_NAME:
            setLocalName((String) newValue);
            return;
        case RDFSPackage.RDF_LIST__SUBJECT_STATEMENT:
            getSubjectStatement().clear();
            getSubjectStatement().addAll((Collection) newValue);
            return;
        case RDFSPackage.RDF_LIST__OBJECT_STATEMENT:
            getObjectStatement().clear();
            getObjectStatement().addAll((Collection) newValue);
            return;
        case RDFSPackage.RDF_LIST__RDFS_IS_DEFINED_BY:
            getRDFSIsDefinedBy().clear();
            getRDFSIsDefinedBy().addAll((Collection) newValue);
            return;
        case RDFSPackage.RDF_LIST__RDF_VALUE:
            getRDFValue().clear();
            getRDFValue().addAll((Collection) newValue);
            return;
        case RDFSPackage.RDF_LIST__RDFS_SEE_ALSO:
            getRDFSSeeAlso().clear();
            getRDFSSeeAlso().addAll((Collection) newValue);
            return;
        case RDFSPackage.RDF_LIST__RDF_TYPE:
            getRDFType().clear();
            getRDFType().addAll((Collection) newValue);
            return;
        case RDFSPackage.RDF_LIST__RDFS_MEMBER:
            getRDFSMember().clear();
            getRDFSMember().addAll((Collection) newValue);
            return;
        case RDFSPackage.RDF_LIST__PREDICATE_STATEMENT:
            getPredicateStatement().clear();
            getPredicateStatement().addAll((Collection) newValue);
            return;
        case RDFSPackage.RDF_LIST__RDFS_COMMENT:
            getRDFSComment().clear();
            getRDFSComment().addAll((Collection) newValue);
            return;
        case RDFSPackage.RDF_LIST__RDFS_LABEL:
            getRDFSLabel().clear();
            getRDFSLabel().addAll((Collection) newValue);
            return;
        case RDFSPackage.RDF_LIST__NAMESPACE:
            setNamespace((Namespace) newValue);
            return;
        case RDFSPackage.RDF_LIST__RDF_REST:
            setRDFRest((RDFList) newValue);
            return;
        case RDFSPackage.RDF_LIST__RDF_FIRST:
            setRDFFirst((RDFSResource) newValue);
            return;
        }
        eDynamicSet(eFeature, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eUnset(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case RDFSPackage.RDF_LIST__LOCAL_NAME:
            setLocalName(LOCAL_NAME_EDEFAULT);
            return;
        case RDFSPackage.RDF_LIST__SUBJECT_STATEMENT:
            getSubjectStatement().clear();
            return;
        case RDFSPackage.RDF_LIST__OBJECT_STATEMENT:
            getObjectStatement().clear();
            return;
        case RDFSPackage.RDF_LIST__RDFS_IS_DEFINED_BY:
            getRDFSIsDefinedBy().clear();
            return;
        case RDFSPackage.RDF_LIST__RDF_VALUE:
            getRDFValue().clear();
            return;
        case RDFSPackage.RDF_LIST__RDFS_SEE_ALSO:
            getRDFSSeeAlso().clear();
            return;
        case RDFSPackage.RDF_LIST__RDF_TYPE:
            getRDFType().clear();
            return;
        case RDFSPackage.RDF_LIST__RDFS_MEMBER:
            getRDFSMember().clear();
            return;
        case RDFSPackage.RDF_LIST__PREDICATE_STATEMENT:
            getPredicateStatement().clear();
            return;
        case RDFSPackage.RDF_LIST__RDFS_COMMENT:
            getRDFSComment().clear();
            return;
        case RDFSPackage.RDF_LIST__RDFS_LABEL:
            getRDFSLabel().clear();
            return;
        case RDFSPackage.RDF_LIST__NAMESPACE:
            setNamespace((Namespace) null);
            return;
        case RDFSPackage.RDF_LIST__RDF_REST:
            setRDFRest((RDFList) null);
            return;
        case RDFSPackage.RDF_LIST__RDF_FIRST:
            setRDFFirst((RDFSResource) null);
            return;
        }
        eDynamicUnset(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean eIsSet(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case RDFSPackage.RDF_LIST__LOCAL_NAME:
            return LOCAL_NAME_EDEFAULT == null ? localName != null
                    : !LOCAL_NAME_EDEFAULT.equals(localName);
        case RDFSPackage.RDF_LIST__URI:
            return URI_EDEFAULT == null ? getURI() != null : !URI_EDEFAULT
                    .equals(getURI());
        case RDFSPackage.RDF_LIST__SUBJECT_STATEMENT:
            return subjectStatement != null && !subjectStatement.isEmpty();
        case RDFSPackage.RDF_LIST__OBJECT_STATEMENT:
            return objectStatement != null && !objectStatement.isEmpty();
        case RDFSPackage.RDF_LIST__RDFS_IS_DEFINED_BY:
            return rdfsIsDefinedBy != null && !rdfsIsDefinedBy.isEmpty();
        case RDFSPackage.RDF_LIST__RDF_VALUE:
            return rdfValue != null && !rdfValue.isEmpty();
        case RDFSPackage.RDF_LIST__RDFS_SEE_ALSO:
            return rdfsSeeAlso != null && !rdfsSeeAlso.isEmpty();
        case RDFSPackage.RDF_LIST__RDF_TYPE:
            return rdfType != null && !rdfType.isEmpty();
        case RDFSPackage.RDF_LIST__RDFS_MEMBER:
            return rdfsMember != null && !rdfsMember.isEmpty();
        case RDFSPackage.RDF_LIST__PREDICATE_STATEMENT:
            return predicateStatement != null && !predicateStatement.isEmpty();
        case RDFSPackage.RDF_LIST__RDFS_COMMENT:
            return rdfsComment != null && !rdfsComment.isEmpty();
        case RDFSPackage.RDF_LIST__RDFS_LABEL:
            return rdfsLabel != null && !rdfsLabel.isEmpty();
        case RDFSPackage.RDF_LIST__NAMESPACE:
            return namespace != null;
        case RDFSPackage.RDF_LIST__RDF_REST:
            return rdfRest != null;
        case RDFSPackage.RDF_LIST__RDF_FIRST:
            return rdfFirst != null;
        }
        return eDynamicIsSet(eFeature);
    }

} //RDFListImpl
